# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.admissionregistration.v1beta1.MutatingWebhook
MutatingWebhook describes an admission webhook and the resources and operations it applies to.

    IoK8sApiAdmissionregistrationV1beta1MutatingWebhook(;
        admissionReviewVersions=nothing,
        clientConfig=nothing,
        failurePolicy=nothing,
        matchPolicy=nothing,
        name=nothing,
        namespaceSelector=nothing,
        objectSelector=nothing,
        reinvocationPolicy=nothing,
        rules=nothing,
        sideEffects=nothing,
        timeoutSeconds=nothing,
    )

    - admissionReviewVersions::Vector{String} : AdmissionReviewVersions is an ordered list of preferred &#x60;AdmissionReview&#x60; versions the Webhook expects. API server will try to use first version in the list which it supports. If none of the versions specified in this list supported by API server, validation will fail for this object. If a persisted webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail and be subject to the failure policy. Default to &#x60;[&#39;v1beta1&#39;]&#x60;.
    - clientConfig::IoK8sApiAdmissionregistrationV1beta1WebhookClientConfig
    - failurePolicy::String : FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail. Defaults to Ignore.
    - matchPolicy::String : matchPolicy defines how the \&quot;rules\&quot; list is used to match incoming requests. Allowed values are \&quot;Exact\&quot; or \&quot;Equivalent\&quot;.  - Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but \&quot;rules\&quot; only included &#x60;apiGroups:[\&quot;apps\&quot;], apiVersions:[\&quot;v1\&quot;], resources: [\&quot;deployments\&quot;]&#x60;, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the webhook.  - Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and \&quot;rules\&quot; only included &#x60;apiGroups:[\&quot;apps\&quot;], apiVersions:[\&quot;v1\&quot;], resources: [\&quot;deployments\&quot;]&#x60;, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the webhook.  Defaults to \&quot;Exact\&quot;
    - name::String : The name of the admission webhook. Name should be fully qualified, e.g., imagepolicy.kubernetes.io, where \&quot;imagepolicy\&quot; is the name of the webhook, and kubernetes.io is the name of the organization. Required.
    - namespaceSelector::IoK8sApimachineryPkgApisMetaV1LabelSelector
    - objectSelector::IoK8sApimachineryPkgApisMetaV1LabelSelector
    - reinvocationPolicy::String : reinvocationPolicy indicates whether this webhook should be called multiple times as part of a single admission evaluation. Allowed values are \&quot;Never\&quot; and \&quot;IfNeeded\&quot;.  Never: the webhook will not be called more than once in a single admission evaluation.  IfNeeded: the webhook will be called at least one additional time as part of the admission evaluation if the object being admitted is modified by other admission plugins after the initial webhook call. Webhooks that specify this option *must* be idempotent, able to process objects they previously admitted. Note: * the number of additional invocations is not guaranteed to be exactly one. * if additional invocations result in further modifications to the object, webhooks are not guaranteed to be invoked again. * webhooks that use this option may be reordered to minimize the number of additional invocations. * to validate an object after all mutations are guaranteed complete, use a validating admission webhook instead.  Defaults to \&quot;Never\&quot;.
    - rules::Vector{IoK8sApiAdmissionregistrationV1beta1RuleWithOperations} : Rules describes what operations on what resources/subresources the webhook cares about. The webhook cares about an operation if it matches _any_ Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.
    - sideEffects::String : SideEffects states whether this webhook has side effects. Acceptable values are: Unknown, None, Some, NoneOnDryRun Webhooks with side effects MUST implement a reconciliation system, since a request may be rejected by a future step in the admission change and the side effects therefore need to be undone. Requests with the dryRun attribute will be auto-rejected if they match a webhook with sideEffects &#x3D;&#x3D; Unknown or Some. Defaults to Unknown.
    - timeoutSeconds::Int64 : TimeoutSeconds specifies the timeout for this webhook. After the timeout passes, the webhook call will be ignored or the API call will fail based on the failure policy. The timeout value must be between 1 and 30 seconds. Default to 30 seconds.
"""
Base.@kwdef mutable struct IoK8sApiAdmissionregistrationV1beta1MutatingWebhook <: OpenAPI.APIModel
    admissionReviewVersions::Union{Nothing, Vector{String}} = nothing
    clientConfig = nothing # spec type: Union{ Nothing, IoK8sApiAdmissionregistrationV1beta1WebhookClientConfig }
    failurePolicy::Union{Nothing, String} = nothing
    matchPolicy::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    namespaceSelector = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1LabelSelector }
    objectSelector = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1LabelSelector }
    reinvocationPolicy::Union{Nothing, String} = nothing
    rules::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiAdmissionregistrationV1beta1RuleWithOperations} }
    sideEffects::Union{Nothing, String} = nothing
    timeoutSeconds::Union{Nothing, Int64} = nothing

    function IoK8sApiAdmissionregistrationV1beta1MutatingWebhook(admissionReviewVersions, clientConfig, failurePolicy, matchPolicy, name, namespaceSelector, objectSelector, reinvocationPolicy, rules, sideEffects, timeoutSeconds, )
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("admissionReviewVersions"), admissionReviewVersions)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("clientConfig"), clientConfig)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("failurePolicy"), failurePolicy)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("matchPolicy"), matchPolicy)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("namespaceSelector"), namespaceSelector)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("objectSelector"), objectSelector)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("reinvocationPolicy"), reinvocationPolicy)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("rules"), rules)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("sideEffects"), sideEffects)
        OpenAPI.validate_property(IoK8sApiAdmissionregistrationV1beta1MutatingWebhook, Symbol("timeoutSeconds"), timeoutSeconds)
        return new(admissionReviewVersions, clientConfig, failurePolicy, matchPolicy, name, namespaceSelector, objectSelector, reinvocationPolicy, rules, sideEffects, timeoutSeconds, )
    end
end # type IoK8sApiAdmissionregistrationV1beta1MutatingWebhook

const _property_types_IoK8sApiAdmissionregistrationV1beta1MutatingWebhook = Dict{Symbol,String}(Symbol("admissionReviewVersions")=>"Vector{String}", Symbol("clientConfig")=>"IoK8sApiAdmissionregistrationV1beta1WebhookClientConfig", Symbol("failurePolicy")=>"String", Symbol("matchPolicy")=>"String", Symbol("name")=>"String", Symbol("namespaceSelector")=>"IoK8sApimachineryPkgApisMetaV1LabelSelector", Symbol("objectSelector")=>"IoK8sApimachineryPkgApisMetaV1LabelSelector", Symbol("reinvocationPolicy")=>"String", Symbol("rules")=>"Vector{IoK8sApiAdmissionregistrationV1beta1RuleWithOperations}", Symbol("sideEffects")=>"String", Symbol("timeoutSeconds")=>"Int64", )
OpenAPI.property_type(::Type{ IoK8sApiAdmissionregistrationV1beta1MutatingWebhook }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAdmissionregistrationV1beta1MutatingWebhook[name]))}

function check_required(o::IoK8sApiAdmissionregistrationV1beta1MutatingWebhook)
    o.clientConfig === nothing && (return false)
    o.name === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAdmissionregistrationV1beta1MutatingWebhook }, name::Symbol, val)
    if name === Symbol("timeoutSeconds")
        OpenAPI.validate_param(name, "IoK8sApiAdmissionregistrationV1beta1MutatingWebhook", :format, val, "int32")
    end
end
