# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.apps.v1.ControllerRevision
ControllerRevision implements an immutable snapshot of state data. Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.

    IoK8sApiAppsV1ControllerRevision(;
        apiVersion=nothing,
        data=nothing,
        kind=nothing,
        metadata=nothing,
        revision=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - data::Any : RawExtension is used to hold extensions in external versions.  To use this, make a field which has RawExtension as its type in your external, versioned struct, and Object in your internal struct. You also need to register your various plugin types.  // Internal package: type MyAPIObject struct {  runtime.TypeMeta &#x60;json:\&quot;,inline\&quot;&#x60;  MyPlugin runtime.Object &#x60;json:\&quot;myPlugin\&quot;&#x60; } type PluginA struct {  AOption string &#x60;json:\&quot;aOption\&quot;&#x60; }  // External package: type MyAPIObject struct {  runtime.TypeMeta &#x60;json:\&quot;,inline\&quot;&#x60;  MyPlugin runtime.RawExtension &#x60;json:\&quot;myPlugin\&quot;&#x60; } type PluginA struct {  AOption string &#x60;json:\&quot;aOption\&quot;&#x60; }  // On the wire, the JSON will look something like this: {  \&quot;kind\&quot;:\&quot;MyAPIObject\&quot;,  \&quot;apiVersion\&quot;:\&quot;v1\&quot;,  \&quot;myPlugin\&quot;: {   \&quot;kind\&quot;:\&quot;PluginA\&quot;,   \&quot;aOption\&quot;:\&quot;foo\&quot;,  }, }  So what happens? Decode first uses json or yaml to unmarshal the serialized data into your external MyAPIObject. That causes the raw JSON to be stored, but not unpacked. The next step is to copy (using pkg/conversion) into the internal struct. The runtime package&#39;s DefaultScheme has conversion functions installed which will unpack the JSON stored in RawExtension, turning it into the correct object type, and storing it in the Object. (TODO: In the case where the object is of an unknown type, a runtime.Unknown object will be created and stored.)
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - revision::Int64 : Revision indicates the revision of the state represented by Data.
"""
Base.@kwdef mutable struct IoK8sApiAppsV1ControllerRevision <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    data::Union{Nothing, Any} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    revision::Union{Nothing, Int64} = nothing

    function IoK8sApiAppsV1ControllerRevision(apiVersion, data, kind, metadata, revision, )
        OpenAPI.validate_property(IoK8sApiAppsV1ControllerRevision, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAppsV1ControllerRevision, Symbol("data"), data)
        OpenAPI.validate_property(IoK8sApiAppsV1ControllerRevision, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAppsV1ControllerRevision, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAppsV1ControllerRevision, Symbol("revision"), revision)
        return new(apiVersion, data, kind, metadata, revision, )
    end
end # type IoK8sApiAppsV1ControllerRevision

const _property_types_IoK8sApiAppsV1ControllerRevision = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("data")=>"Any", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("revision")=>"Int64", )
OpenAPI.property_type(::Type{ IoK8sApiAppsV1ControllerRevision }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAppsV1ControllerRevision[name]))}

function check_required(o::IoK8sApiAppsV1ControllerRevision)
    o.revision === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAppsV1ControllerRevision }, name::Symbol, val)
    if name === Symbol("revision")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1ControllerRevision", :format, val, "int64")
    end
end
