# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.apps.v1.ReplicaSetStatus
ReplicaSetStatus represents the current status of a ReplicaSet.

    IoK8sApiAppsV1ReplicaSetStatus(;
        availableReplicas=nothing,
        conditions=nothing,
        fullyLabeledReplicas=nothing,
        observedGeneration=nothing,
        readyReplicas=nothing,
        replicas=nothing,
    )

    - availableReplicas::Int64 : The number of available replicas (ready for at least minReadySeconds) for this replica set.
    - conditions::Vector{IoK8sApiAppsV1ReplicaSetCondition} : Represents the latest available observations of a replica set&#39;s current state.
    - fullyLabeledReplicas::Int64 : The number of pods that have labels matching the labels of the pod template of the replicaset.
    - observedGeneration::Int64 : ObservedGeneration reflects the generation of the most recently observed ReplicaSet.
    - readyReplicas::Int64 : The number of ready replicas for this replica set.
    - replicas::Int64 : Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller
"""
Base.@kwdef mutable struct IoK8sApiAppsV1ReplicaSetStatus <: OpenAPI.APIModel
    availableReplicas::Union{Nothing, Int64} = nothing
    conditions::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiAppsV1ReplicaSetCondition} }
    fullyLabeledReplicas::Union{Nothing, Int64} = nothing
    observedGeneration::Union{Nothing, Int64} = nothing
    readyReplicas::Union{Nothing, Int64} = nothing
    replicas::Union{Nothing, Int64} = nothing

    function IoK8sApiAppsV1ReplicaSetStatus(availableReplicas, conditions, fullyLabeledReplicas, observedGeneration, readyReplicas, replicas, )
        OpenAPI.validate_property(IoK8sApiAppsV1ReplicaSetStatus, Symbol("availableReplicas"), availableReplicas)
        OpenAPI.validate_property(IoK8sApiAppsV1ReplicaSetStatus, Symbol("conditions"), conditions)
        OpenAPI.validate_property(IoK8sApiAppsV1ReplicaSetStatus, Symbol("fullyLabeledReplicas"), fullyLabeledReplicas)
        OpenAPI.validate_property(IoK8sApiAppsV1ReplicaSetStatus, Symbol("observedGeneration"), observedGeneration)
        OpenAPI.validate_property(IoK8sApiAppsV1ReplicaSetStatus, Symbol("readyReplicas"), readyReplicas)
        OpenAPI.validate_property(IoK8sApiAppsV1ReplicaSetStatus, Symbol("replicas"), replicas)
        return new(availableReplicas, conditions, fullyLabeledReplicas, observedGeneration, readyReplicas, replicas, )
    end
end # type IoK8sApiAppsV1ReplicaSetStatus

const _property_types_IoK8sApiAppsV1ReplicaSetStatus = Dict{Symbol,String}(Symbol("availableReplicas")=>"Int64", Symbol("conditions")=>"Vector{IoK8sApiAppsV1ReplicaSetCondition}", Symbol("fullyLabeledReplicas")=>"Int64", Symbol("observedGeneration")=>"Int64", Symbol("readyReplicas")=>"Int64", Symbol("replicas")=>"Int64", )
OpenAPI.property_type(::Type{ IoK8sApiAppsV1ReplicaSetStatus }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAppsV1ReplicaSetStatus[name]))}

function check_required(o::IoK8sApiAppsV1ReplicaSetStatus)
    o.replicas === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAppsV1ReplicaSetStatus }, name::Symbol, val)
    if name === Symbol("availableReplicas")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1ReplicaSetStatus", :format, val, "int32")
    end
    if name === Symbol("fullyLabeledReplicas")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1ReplicaSetStatus", :format, val, "int32")
    end
    if name === Symbol("observedGeneration")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1ReplicaSetStatus", :format, val, "int64")
    end
    if name === Symbol("readyReplicas")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1ReplicaSetStatus", :format, val, "int32")
    end
    if name === Symbol("replicas")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1ReplicaSetStatus", :format, val, "int32")
    end
end
