# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.apps.v1.StatefulSet
StatefulSet represents a set of pods with consistent identities. Identities are defined as:  - Network: A single stable DNS and hostname.  - Storage: As many VolumeClaims as requested. The StatefulSet guarantees that a given network identity will always map to the same storage identity.

    IoK8sApiAppsV1StatefulSet(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiAppsV1StatefulSetSpec
    - status::IoK8sApiAppsV1StatefulSetStatus
"""
Base.@kwdef mutable struct IoK8sApiAppsV1StatefulSet <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiAppsV1StatefulSetSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiAppsV1StatefulSetStatus }

    function IoK8sApiAppsV1StatefulSet(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiAppsV1StatefulSet, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAppsV1StatefulSet, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAppsV1StatefulSet, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAppsV1StatefulSet, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiAppsV1StatefulSet, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiAppsV1StatefulSet

const _property_types_IoK8sApiAppsV1StatefulSet = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiAppsV1StatefulSetSpec", Symbol("status")=>"IoK8sApiAppsV1StatefulSetStatus", )
OpenAPI.property_type(::Type{ IoK8sApiAppsV1StatefulSet }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAppsV1StatefulSet[name]))}

function check_required(o::IoK8sApiAppsV1StatefulSet)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAppsV1StatefulSet }, name::Symbol, val)
end
