# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.apps.v1beta2.DeploymentSpec
DeploymentSpec is the specification of the desired behavior of the Deployment.

    IoK8sApiAppsV1beta2DeploymentSpec(;
        minReadySeconds=nothing,
        paused=nothing,
        progressDeadlineSeconds=nothing,
        replicas=nothing,
        revisionHistoryLimit=nothing,
        selector=nothing,
        strategy=nothing,
        template=nothing,
    )

    - minReadySeconds::Int64 : Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)
    - paused::Bool : Indicates that the deployment is paused.
    - progressDeadlineSeconds::Int64 : The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.
    - replicas::Int64 : Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.
    - revisionHistoryLimit::Int64 : The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.
    - selector::IoK8sApimachineryPkgApisMetaV1LabelSelector
    - strategy::IoK8sApiAppsV1beta2DeploymentStrategy
    - template::IoK8sApiCoreV1PodTemplateSpec
"""
Base.@kwdef mutable struct IoK8sApiAppsV1beta2DeploymentSpec <: OpenAPI.APIModel
    minReadySeconds::Union{Nothing, Int64} = nothing
    paused::Union{Nothing, Bool} = nothing
    progressDeadlineSeconds::Union{Nothing, Int64} = nothing
    replicas::Union{Nothing, Int64} = nothing
    revisionHistoryLimit::Union{Nothing, Int64} = nothing
    selector = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1LabelSelector }
    strategy = nothing # spec type: Union{ Nothing, IoK8sApiAppsV1beta2DeploymentStrategy }
    template = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1PodTemplateSpec }

    function IoK8sApiAppsV1beta2DeploymentSpec(minReadySeconds, paused, progressDeadlineSeconds, replicas, revisionHistoryLimit, selector, strategy, template, )
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("minReadySeconds"), minReadySeconds)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("paused"), paused)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("progressDeadlineSeconds"), progressDeadlineSeconds)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("replicas"), replicas)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("revisionHistoryLimit"), revisionHistoryLimit)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("selector"), selector)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("strategy"), strategy)
        OpenAPI.validate_property(IoK8sApiAppsV1beta2DeploymentSpec, Symbol("template"), template)
        return new(minReadySeconds, paused, progressDeadlineSeconds, replicas, revisionHistoryLimit, selector, strategy, template, )
    end
end # type IoK8sApiAppsV1beta2DeploymentSpec

const _property_types_IoK8sApiAppsV1beta2DeploymentSpec = Dict{Symbol,String}(Symbol("minReadySeconds")=>"Int64", Symbol("paused")=>"Bool", Symbol("progressDeadlineSeconds")=>"Int64", Symbol("replicas")=>"Int64", Symbol("revisionHistoryLimit")=>"Int64", Symbol("selector")=>"IoK8sApimachineryPkgApisMetaV1LabelSelector", Symbol("strategy")=>"IoK8sApiAppsV1beta2DeploymentStrategy", Symbol("template")=>"IoK8sApiCoreV1PodTemplateSpec", )
OpenAPI.property_type(::Type{ IoK8sApiAppsV1beta2DeploymentSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAppsV1beta2DeploymentSpec[name]))}

function check_required(o::IoK8sApiAppsV1beta2DeploymentSpec)
    o.selector === nothing && (return false)
    o.template === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAppsV1beta2DeploymentSpec }, name::Symbol, val)
    if name === Symbol("minReadySeconds")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1beta2DeploymentSpec", :format, val, "int32")
    end
    if name === Symbol("progressDeadlineSeconds")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1beta2DeploymentSpec", :format, val, "int32")
    end
    if name === Symbol("replicas")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1beta2DeploymentSpec", :format, val, "int32")
    end
    if name === Symbol("revisionHistoryLimit")
        OpenAPI.validate_param(name, "IoK8sApiAppsV1beta2DeploymentSpec", :format, val, "int32")
    end
end
