# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.authentication.v1.TokenRequest
TokenRequest requests a token for a given service account.

    IoK8sApiAuthenticationV1TokenRequest(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiAuthenticationV1TokenRequestSpec
    - status::IoK8sApiAuthenticationV1TokenRequestStatus
"""
Base.@kwdef mutable struct IoK8sApiAuthenticationV1TokenRequest <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiAuthenticationV1TokenRequestSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiAuthenticationV1TokenRequestStatus }

    function IoK8sApiAuthenticationV1TokenRequest(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenRequest, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenRequest, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenRequest, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenRequest, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenRequest, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiAuthenticationV1TokenRequest

const _property_types_IoK8sApiAuthenticationV1TokenRequest = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiAuthenticationV1TokenRequestSpec", Symbol("status")=>"IoK8sApiAuthenticationV1TokenRequestStatus", )
OpenAPI.property_type(::Type{ IoK8sApiAuthenticationV1TokenRequest }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAuthenticationV1TokenRequest[name]))}

function check_required(o::IoK8sApiAuthenticationV1TokenRequest)
    o.spec === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAuthenticationV1TokenRequest }, name::Symbol, val)
end
