# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.authentication.v1.TokenReview
TokenReview attempts to authenticate a token to a known user. Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.

    IoK8sApiAuthenticationV1TokenReview(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiAuthenticationV1TokenReviewSpec
    - status::IoK8sApiAuthenticationV1TokenReviewStatus
"""
Base.@kwdef mutable struct IoK8sApiAuthenticationV1TokenReview <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiAuthenticationV1TokenReviewSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiAuthenticationV1TokenReviewStatus }

    function IoK8sApiAuthenticationV1TokenReview(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenReview, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenReview, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenReview, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenReview, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiAuthenticationV1TokenReview, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiAuthenticationV1TokenReview

const _property_types_IoK8sApiAuthenticationV1TokenReview = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiAuthenticationV1TokenReviewSpec", Symbol("status")=>"IoK8sApiAuthenticationV1TokenReviewStatus", )
OpenAPI.property_type(::Type{ IoK8sApiAuthenticationV1TokenReview }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAuthenticationV1TokenReview[name]))}

function check_required(o::IoK8sApiAuthenticationV1TokenReview)
    o.spec === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAuthenticationV1TokenReview }, name::Symbol, val)
end
