# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.authorization.v1.LocalSubjectAccessReview
LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace. Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.

    IoK8sApiAuthorizationV1LocalSubjectAccessReview(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiAuthorizationV1SubjectAccessReviewSpec
    - status::IoK8sApiAuthorizationV1SubjectAccessReviewStatus
"""
Base.@kwdef mutable struct IoK8sApiAuthorizationV1LocalSubjectAccessReview <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiAuthorizationV1SubjectAccessReviewSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiAuthorizationV1SubjectAccessReviewStatus }

    function IoK8sApiAuthorizationV1LocalSubjectAccessReview(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiAuthorizationV1LocalSubjectAccessReview, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1LocalSubjectAccessReview, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1LocalSubjectAccessReview, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1LocalSubjectAccessReview, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1LocalSubjectAccessReview, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiAuthorizationV1LocalSubjectAccessReview

const _property_types_IoK8sApiAuthorizationV1LocalSubjectAccessReview = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiAuthorizationV1SubjectAccessReviewSpec", Symbol("status")=>"IoK8sApiAuthorizationV1SubjectAccessReviewStatus", )
OpenAPI.property_type(::Type{ IoK8sApiAuthorizationV1LocalSubjectAccessReview }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAuthorizationV1LocalSubjectAccessReview[name]))}

function check_required(o::IoK8sApiAuthorizationV1LocalSubjectAccessReview)
    o.spec === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAuthorizationV1LocalSubjectAccessReview }, name::Symbol, val)
end
