# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.authorization.v1beta1.SelfSubjectAccessReview
SelfSubjectAccessReview checks whether or the current user can perform an action.  Not filling in a spec.namespace means \&quot;in all namespaces\&quot;.  Self is a special case, because users should always be able to check whether they can perform an action

    IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiAuthorizationV1beta1SelfSubjectAccessReviewSpec
    - status::IoK8sApiAuthorizationV1beta1SubjectAccessReviewStatus
"""
Base.@kwdef mutable struct IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiAuthorizationV1beta1SelfSubjectAccessReviewSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiAuthorizationV1beta1SubjectAccessReviewStatus }

    function IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview

const _property_types_IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiAuthorizationV1beta1SelfSubjectAccessReviewSpec", Symbol("status")=>"IoK8sApiAuthorizationV1beta1SubjectAccessReviewStatus", )
OpenAPI.property_type(::Type{ IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview[name]))}

function check_required(o::IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview)
    o.spec === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAuthorizationV1beta1SelfSubjectAccessReview }, name::Symbol, val)
end
