# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.autoscaling.v2beta2.HorizontalPodAutoscaler
HorizontalPodAutoscaler is the configuration for a horizontal pod autoscaler, which automatically manages the replica count of any resource implementing the scale subresource based on the metrics specified.

    IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiAutoscalingV2beta2HorizontalPodAutoscalerSpec
    - status::IoK8sApiAutoscalingV2beta2HorizontalPodAutoscalerStatus
"""
Base.@kwdef mutable struct IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiAutoscalingV2beta2HorizontalPodAutoscalerSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiAutoscalingV2beta2HorizontalPodAutoscalerStatus }

    function IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler

const _property_types_IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiAutoscalingV2beta2HorizontalPodAutoscalerSpec", Symbol("status")=>"IoK8sApiAutoscalingV2beta2HorizontalPodAutoscalerStatus", )
OpenAPI.property_type(::Type{ IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler[name]))}

function check_required(o::IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAutoscalingV2beta2HorizontalPodAutoscaler }, name::Symbol, val)
end
