# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.autoscaling.v2beta2.ResourceMetricSource
ResourceMetricSource indicates how to scale on a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  The values will be averaged together before being compared to the target.  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the \&quot;pods\&quot; source.  Only one \&quot;target\&quot; type should be set.

    IoK8sApiAutoscalingV2beta2ResourceMetricSource(;
        name=nothing,
        target=nothing,
    )

    - name::String : name is the name of the resource in question.
    - target::IoK8sApiAutoscalingV2beta2MetricTarget
"""
Base.@kwdef mutable struct IoK8sApiAutoscalingV2beta2ResourceMetricSource <: OpenAPI.APIModel
    name::Union{Nothing, String} = nothing
    target = nothing # spec type: Union{ Nothing, IoK8sApiAutoscalingV2beta2MetricTarget }

    function IoK8sApiAutoscalingV2beta2ResourceMetricSource(name, target, )
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2ResourceMetricSource, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApiAutoscalingV2beta2ResourceMetricSource, Symbol("target"), target)
        return new(name, target, )
    end
end # type IoK8sApiAutoscalingV2beta2ResourceMetricSource

const _property_types_IoK8sApiAutoscalingV2beta2ResourceMetricSource = Dict{Symbol,String}(Symbol("name")=>"String", Symbol("target")=>"IoK8sApiAutoscalingV2beta2MetricTarget", )
OpenAPI.property_type(::Type{ IoK8sApiAutoscalingV2beta2ResourceMetricSource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiAutoscalingV2beta2ResourceMetricSource[name]))}

function check_required(o::IoK8sApiAutoscalingV2beta2ResourceMetricSource)
    o.name === nothing && (return false)
    o.target === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiAutoscalingV2beta2ResourceMetricSource }, name::Symbol, val)
end
