# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.batch.v1.JobCondition
JobCondition describes current state of a job.

    IoK8sApiBatchV1JobCondition(;
        lastProbeTime=nothing,
        lastTransitionTime=nothing,
        message=nothing,
        reason=nothing,
        status=nothing,
        type=nothing,
    )

    - lastProbeTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - lastTransitionTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - message::String : Human readable message indicating details about last transition.
    - reason::String : (brief) reason for the condition&#39;s last transition.
    - status::String : Status of the condition, one of True, False, Unknown.
    - type::String : Type of job condition, Complete or Failed.
"""
Base.@kwdef mutable struct IoK8sApiBatchV1JobCondition <: OpenAPI.APIModel
    lastProbeTime::Union{Nothing, ZonedDateTime} = nothing
    lastTransitionTime::Union{Nothing, ZonedDateTime} = nothing
    message::Union{Nothing, String} = nothing
    reason::Union{Nothing, String} = nothing
    status::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing

    function IoK8sApiBatchV1JobCondition(lastProbeTime, lastTransitionTime, message, reason, status, type, )
        OpenAPI.validate_property(IoK8sApiBatchV1JobCondition, Symbol("lastProbeTime"), lastProbeTime)
        OpenAPI.validate_property(IoK8sApiBatchV1JobCondition, Symbol("lastTransitionTime"), lastTransitionTime)
        OpenAPI.validate_property(IoK8sApiBatchV1JobCondition, Symbol("message"), message)
        OpenAPI.validate_property(IoK8sApiBatchV1JobCondition, Symbol("reason"), reason)
        OpenAPI.validate_property(IoK8sApiBatchV1JobCondition, Symbol("status"), status)
        OpenAPI.validate_property(IoK8sApiBatchV1JobCondition, Symbol("type"), type)
        return new(lastProbeTime, lastTransitionTime, message, reason, status, type, )
    end
end # type IoK8sApiBatchV1JobCondition

const _property_types_IoK8sApiBatchV1JobCondition = Dict{Symbol,String}(Symbol("lastProbeTime")=>"ZonedDateTime", Symbol("lastTransitionTime")=>"ZonedDateTime", Symbol("message")=>"String", Symbol("reason")=>"String", Symbol("status")=>"String", Symbol("type")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiBatchV1JobCondition }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiBatchV1JobCondition[name]))}

function check_required(o::IoK8sApiBatchV1JobCondition)
    o.status === nothing && (return false)
    o.type === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiBatchV1JobCondition }, name::Symbol, val)
    if name === Symbol("lastProbeTime")
        OpenAPI.validate_param(name, "IoK8sApiBatchV1JobCondition", :format, val, "date-time")
    end
    if name === Symbol("lastTransitionTime")
        OpenAPI.validate_param(name, "IoK8sApiBatchV1JobCondition", :format, val, "date-time")
    end
end
