# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.AWSElasticBlockStoreVolumeSource
Represents a Persistent Disk resource in AWS.  An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.

    IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource(;
        fsType=nothing,
        partition=nothing,
        readOnly=nothing,
        volumeID=nothing,
    )

    - fsType::String : Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \&quot;ext4\&quot;, \&quot;xfs\&quot;, \&quot;ntfs\&quot;. Implicitly inferred to be \&quot;ext4\&quot; if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
    - partition::Int64 : The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \&quot;1\&quot;. Similarly, the volume partition for /dev/sda is \&quot;0\&quot; (or you can leave the property empty).
    - readOnly::Bool : Specify \&quot;true\&quot; to force and set the ReadOnly property in VolumeMounts to \&quot;true\&quot;. If omitted, the default is \&quot;false\&quot;. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
    - volumeID::String : Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
"""
Base.@kwdef mutable struct IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource <: OpenAPI.APIModel
    fsType::Union{Nothing, String} = nothing
    partition::Union{Nothing, Int64} = nothing
    readOnly::Union{Nothing, Bool} = nothing
    volumeID::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource(fsType, partition, readOnly, volumeID, )
        OpenAPI.validate_property(IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource, Symbol("fsType"), fsType)
        OpenAPI.validate_property(IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource, Symbol("partition"), partition)
        OpenAPI.validate_property(IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource, Symbol("readOnly"), readOnly)
        OpenAPI.validate_property(IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource, Symbol("volumeID"), volumeID)
        return new(fsType, partition, readOnly, volumeID, )
    end
end # type IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource

const _property_types_IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource = Dict{Symbol,String}(Symbol("fsType")=>"String", Symbol("partition")=>"Int64", Symbol("readOnly")=>"Bool", Symbol("volumeID")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource[name]))}

function check_required(o::IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource)
    o.volumeID === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource }, name::Symbol, val)
    if name === Symbol("partition")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1AWSElasticBlockStoreVolumeSource", :format, val, "int32")
    end
end
