# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ConfigMapVolumeSource
Adapts a ConfigMap into a volume.  The contents of the target ConfigMap&#39;s Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.

    IoK8sApiCoreV1ConfigMapVolumeSource(;
        defaultMode=nothing,
        items=nothing,
        name=nothing,
        optional=nothing,
    )

    - defaultMode::Int64 : Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
    - items::Vector{IoK8sApiCoreV1KeyToPath} : If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the &#39;..&#39; path or start with &#39;..&#39;.
    - name::String : Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    - optional::Bool : Specify whether the ConfigMap or its keys must be defined
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ConfigMapVolumeSource <: OpenAPI.APIModel
    defaultMode::Union{Nothing, Int64} = nothing
    items::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1KeyToPath} }
    name::Union{Nothing, String} = nothing
    optional::Union{Nothing, Bool} = nothing

    function IoK8sApiCoreV1ConfigMapVolumeSource(defaultMode, items, name, optional, )
        OpenAPI.validate_property(IoK8sApiCoreV1ConfigMapVolumeSource, Symbol("defaultMode"), defaultMode)
        OpenAPI.validate_property(IoK8sApiCoreV1ConfigMapVolumeSource, Symbol("items"), items)
        OpenAPI.validate_property(IoK8sApiCoreV1ConfigMapVolumeSource, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApiCoreV1ConfigMapVolumeSource, Symbol("optional"), optional)
        return new(defaultMode, items, name, optional, )
    end
end # type IoK8sApiCoreV1ConfigMapVolumeSource

const _property_types_IoK8sApiCoreV1ConfigMapVolumeSource = Dict{Symbol,String}(Symbol("defaultMode")=>"Int64", Symbol("items")=>"Vector{IoK8sApiCoreV1KeyToPath}", Symbol("name")=>"String", Symbol("optional")=>"Bool", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ConfigMapVolumeSource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ConfigMapVolumeSource[name]))}

function check_required(o::IoK8sApiCoreV1ConfigMapVolumeSource)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ConfigMapVolumeSource }, name::Symbol, val)
    if name === Symbol("defaultMode")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ConfigMapVolumeSource", :format, val, "int32")
    end
end
