# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.EventSeries
EventSeries contain information on series of events, i.e. thing that was/is happening continuously for some time.

    IoK8sApiCoreV1EventSeries(;
        count=nothing,
        lastObservedTime=nothing,
        state=nothing,
    )

    - count::Int64 : Number of occurrences in this series up to the last heartbeat time
    - lastObservedTime::ZonedDateTime : MicroTime is version of Time with microsecond level precision.
    - state::String : State of this Series: Ongoing or Finished Deprecated. Planned removal for 1.18
"""
Base.@kwdef mutable struct IoK8sApiCoreV1EventSeries <: OpenAPI.APIModel
    count::Union{Nothing, Int64} = nothing
    lastObservedTime::Union{Nothing, ZonedDateTime} = nothing
    state::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1EventSeries(count, lastObservedTime, state, )
        OpenAPI.validate_property(IoK8sApiCoreV1EventSeries, Symbol("count"), count)
        OpenAPI.validate_property(IoK8sApiCoreV1EventSeries, Symbol("lastObservedTime"), lastObservedTime)
        OpenAPI.validate_property(IoK8sApiCoreV1EventSeries, Symbol("state"), state)
        return new(count, lastObservedTime, state, )
    end
end # type IoK8sApiCoreV1EventSeries

const _property_types_IoK8sApiCoreV1EventSeries = Dict{Symbol,String}(Symbol("count")=>"Int64", Symbol("lastObservedTime")=>"ZonedDateTime", Symbol("state")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1EventSeries }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1EventSeries[name]))}

function check_required(o::IoK8sApiCoreV1EventSeries)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1EventSeries }, name::Symbol, val)
    if name === Symbol("count")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1EventSeries", :format, val, "int32")
    end
    if name === Symbol("lastObservedTime")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1EventSeries", :format, val, "date-time")
    end
end
