# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.LimitRange
LimitRange sets resource usage limits for each kind of resource in a Namespace.

    IoK8sApiCoreV1LimitRange(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiCoreV1LimitRangeSpec
"""
Base.@kwdef mutable struct IoK8sApiCoreV1LimitRange <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1LimitRangeSpec }

    function IoK8sApiCoreV1LimitRange(apiVersion, kind, metadata, spec, )
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRange, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRange, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRange, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRange, Symbol("spec"), spec)
        return new(apiVersion, kind, metadata, spec, )
    end
end # type IoK8sApiCoreV1LimitRange

const _property_types_IoK8sApiCoreV1LimitRange = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiCoreV1LimitRangeSpec", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1LimitRange }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1LimitRange[name]))}

function check_required(o::IoK8sApiCoreV1LimitRange)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1LimitRange }, name::Symbol, val)
end
