# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.LimitRangeItem
LimitRangeItem defines a min/max usage limit for any resource that matches on kind.

    IoK8sApiCoreV1LimitRangeItem(;
        default=nothing,
        defaultRequest=nothing,
        max=nothing,
        maxLimitRequestRatio=nothing,
        min=nothing,
        type=nothing,
    )

    - default::Dict{String, String} : Default resource requirement limit value by resource name if resource limit is omitted.
    - defaultRequest::Dict{String, String} : DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.
    - max::Dict{String, String} : Max usage constraints on this kind by resource name.
    - maxLimitRequestRatio::Dict{String, String} : MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; this represents the max burst for the named resource.
    - min::Dict{String, String} : Min usage constraints on this kind by resource name.
    - type::String : Type of resource that this limit applies to.
"""
Base.@kwdef mutable struct IoK8sApiCoreV1LimitRangeItem <: OpenAPI.APIModel
    default::Union{Nothing, Dict{String, String}} = nothing
    defaultRequest::Union{Nothing, Dict{String, String}} = nothing
    max::Union{Nothing, Dict{String, String}} = nothing
    maxLimitRequestRatio::Union{Nothing, Dict{String, String}} = nothing
    min::Union{Nothing, Dict{String, String}} = nothing
    type::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1LimitRangeItem(default, defaultRequest, max, maxLimitRequestRatio, min, type, )
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("default"), default)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("defaultRequest"), defaultRequest)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("max"), max)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("maxLimitRequestRatio"), maxLimitRequestRatio)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("min"), min)
        OpenAPI.validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("type"), type)
        return new(default, defaultRequest, max, maxLimitRequestRatio, min, type, )
    end
end # type IoK8sApiCoreV1LimitRangeItem

const _property_types_IoK8sApiCoreV1LimitRangeItem = Dict{Symbol,String}(Symbol("default")=>"Dict{String, String}", Symbol("defaultRequest")=>"Dict{String, String}", Symbol("max")=>"Dict{String, String}", Symbol("maxLimitRequestRatio")=>"Dict{String, String}", Symbol("min")=>"Dict{String, String}", Symbol("type")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1LimitRangeItem }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1LimitRangeItem[name]))}

function check_required(o::IoK8sApiCoreV1LimitRangeItem)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1LimitRangeItem }, name::Symbol, val)
end
