# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.NodeAffinity
Node affinity is a group of node affinity scheduling rules.

    IoK8sApiCoreV1NodeAffinity(;
        preferredDuringSchedulingIgnoredDuringExecution=nothing,
        requiredDuringSchedulingIgnoredDuringExecution=nothing,
    )

    - preferredDuringSchedulingIgnoredDuringExecution::Vector{IoK8sApiCoreV1PreferredSchedulingTerm} : The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \&quot;weight\&quot; to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.
    - requiredDuringSchedulingIgnoredDuringExecution::IoK8sApiCoreV1NodeSelector
"""
Base.@kwdef mutable struct IoK8sApiCoreV1NodeAffinity <: OpenAPI.APIModel
    preferredDuringSchedulingIgnoredDuringExecution::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1PreferredSchedulingTerm} }
    requiredDuringSchedulingIgnoredDuringExecution = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1NodeSelector }

    function IoK8sApiCoreV1NodeAffinity(preferredDuringSchedulingIgnoredDuringExecution, requiredDuringSchedulingIgnoredDuringExecution, )
        OpenAPI.validate_property(IoK8sApiCoreV1NodeAffinity, Symbol("preferredDuringSchedulingIgnoredDuringExecution"), preferredDuringSchedulingIgnoredDuringExecution)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeAffinity, Symbol("requiredDuringSchedulingIgnoredDuringExecution"), requiredDuringSchedulingIgnoredDuringExecution)
        return new(preferredDuringSchedulingIgnoredDuringExecution, requiredDuringSchedulingIgnoredDuringExecution, )
    end
end # type IoK8sApiCoreV1NodeAffinity

const _property_types_IoK8sApiCoreV1NodeAffinity = Dict{Symbol,String}(Symbol("preferredDuringSchedulingIgnoredDuringExecution")=>"Vector{IoK8sApiCoreV1PreferredSchedulingTerm}", Symbol("requiredDuringSchedulingIgnoredDuringExecution")=>"IoK8sApiCoreV1NodeSelector", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1NodeAffinity }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1NodeAffinity[name]))}

function check_required(o::IoK8sApiCoreV1NodeAffinity)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1NodeAffinity }, name::Symbol, val)
end
