# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.NodeCondition
NodeCondition contains condition information for a node.

    IoK8sApiCoreV1NodeCondition(;
        lastHeartbeatTime=nothing,
        lastTransitionTime=nothing,
        message=nothing,
        reason=nothing,
        status=nothing,
        type=nothing,
    )

    - lastHeartbeatTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - lastTransitionTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - message::String : Human readable message indicating details about last transition.
    - reason::String : (brief) reason for the condition&#39;s last transition.
    - status::String : Status of the condition, one of True, False, Unknown.
    - type::String : Type of node condition.
"""
Base.@kwdef mutable struct IoK8sApiCoreV1NodeCondition <: OpenAPI.APIModel
    lastHeartbeatTime::Union{Nothing, ZonedDateTime} = nothing
    lastTransitionTime::Union{Nothing, ZonedDateTime} = nothing
    message::Union{Nothing, String} = nothing
    reason::Union{Nothing, String} = nothing
    status::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1NodeCondition(lastHeartbeatTime, lastTransitionTime, message, reason, status, type, )
        OpenAPI.validate_property(IoK8sApiCoreV1NodeCondition, Symbol("lastHeartbeatTime"), lastHeartbeatTime)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeCondition, Symbol("lastTransitionTime"), lastTransitionTime)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeCondition, Symbol("message"), message)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeCondition, Symbol("reason"), reason)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeCondition, Symbol("status"), status)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeCondition, Symbol("type"), type)
        return new(lastHeartbeatTime, lastTransitionTime, message, reason, status, type, )
    end
end # type IoK8sApiCoreV1NodeCondition

const _property_types_IoK8sApiCoreV1NodeCondition = Dict{Symbol,String}(Symbol("lastHeartbeatTime")=>"ZonedDateTime", Symbol("lastTransitionTime")=>"ZonedDateTime", Symbol("message")=>"String", Symbol("reason")=>"String", Symbol("status")=>"String", Symbol("type")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1NodeCondition }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1NodeCondition[name]))}

function check_required(o::IoK8sApiCoreV1NodeCondition)
    o.status === nothing && (return false)
    o.type === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1NodeCondition }, name::Symbol, val)
    if name === Symbol("lastHeartbeatTime")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1NodeCondition", :format, val, "date-time")
    end
    if name === Symbol("lastTransitionTime")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1NodeCondition", :format, val, "date-time")
    end
end
