# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.NodeConfigStatus
NodeConfigStatus describes the status of the config assigned by Node.Spec.ConfigSource.

    IoK8sApiCoreV1NodeConfigStatus(;
        active=nothing,
        assigned=nothing,
        error=nothing,
        lastKnownGood=nothing,
    )

    - active::IoK8sApiCoreV1NodeConfigSource
    - assigned::IoK8sApiCoreV1NodeConfigSource
    - error::String : Error describes any problems reconciling the Spec.ConfigSource to the Active config. Errors may occur, for example, attempting to checkpoint Spec.ConfigSource to the local Assigned record, attempting to checkpoint the payload associated with Spec.ConfigSource, attempting to load or validate the Assigned config, etc. Errors may occur at different points while syncing config. Earlier errors (e.g. download or checkpointing errors) will not result in a rollback to LastKnownGood, and may resolve across Kubelet retries. Later errors (e.g. loading or validating a checkpointed config) will result in a rollback to LastKnownGood. In the latter case, it is usually possible to resolve the error by fixing the config assigned in Spec.ConfigSource. You can find additional information for debugging by searching the error message in the Kubelet log. Error is a human-readable description of the error state; machines can check whether or not Error is empty, but should not rely on the stability of the Error text across Kubelet versions.
    - lastKnownGood::IoK8sApiCoreV1NodeConfigSource
"""
Base.@kwdef mutable struct IoK8sApiCoreV1NodeConfigStatus <: OpenAPI.APIModel
    active = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1NodeConfigSource }
    assigned = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1NodeConfigSource }
    error::Union{Nothing, String} = nothing
    lastKnownGood = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1NodeConfigSource }

    function IoK8sApiCoreV1NodeConfigStatus(active, assigned, error, lastKnownGood, )
        OpenAPI.validate_property(IoK8sApiCoreV1NodeConfigStatus, Symbol("active"), active)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeConfigStatus, Symbol("assigned"), assigned)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeConfigStatus, Symbol("error"), error)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeConfigStatus, Symbol("lastKnownGood"), lastKnownGood)
        return new(active, assigned, error, lastKnownGood, )
    end
end # type IoK8sApiCoreV1NodeConfigStatus

const _property_types_IoK8sApiCoreV1NodeConfigStatus = Dict{Symbol,String}(Symbol("active")=>"IoK8sApiCoreV1NodeConfigSource", Symbol("assigned")=>"IoK8sApiCoreV1NodeConfigSource", Symbol("error")=>"String", Symbol("lastKnownGood")=>"IoK8sApiCoreV1NodeConfigSource", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1NodeConfigStatus }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1NodeConfigStatus[name]))}

function check_required(o::IoK8sApiCoreV1NodeConfigStatus)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1NodeConfigStatus }, name::Symbol, val)
end
