# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.NodeSelectorRequirement
A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

    IoK8sApiCoreV1NodeSelectorRequirement(;
        key=nothing,
        operator=nothing,
        values=nothing,
    )

    - key::String : The label key that the selector applies to.
    - operator::String : Represents a key&#39;s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
    - values::Vector{String} : An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
"""
Base.@kwdef mutable struct IoK8sApiCoreV1NodeSelectorRequirement <: OpenAPI.APIModel
    key::Union{Nothing, String} = nothing
    operator::Union{Nothing, String} = nothing
    values::Union{Nothing, Vector{String}} = nothing

    function IoK8sApiCoreV1NodeSelectorRequirement(key, operator, values, )
        OpenAPI.validate_property(IoK8sApiCoreV1NodeSelectorRequirement, Symbol("key"), key)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeSelectorRequirement, Symbol("operator"), operator)
        OpenAPI.validate_property(IoK8sApiCoreV1NodeSelectorRequirement, Symbol("values"), values)
        return new(key, operator, values, )
    end
end # type IoK8sApiCoreV1NodeSelectorRequirement

const _property_types_IoK8sApiCoreV1NodeSelectorRequirement = Dict{Symbol,String}(Symbol("key")=>"String", Symbol("operator")=>"String", Symbol("values")=>"Vector{String}", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1NodeSelectorRequirement }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1NodeSelectorRequirement[name]))}

function check_required(o::IoK8sApiCoreV1NodeSelectorRequirement)
    o.key === nothing && (return false)
    o.operator === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1NodeSelectorRequirement }, name::Symbol, val)
end
