# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ObjectReference
ObjectReference contains enough information to let you inspect or modify the referred object.

    IoK8sApiCoreV1ObjectReference(;
        apiVersion=nothing,
        fieldPath=nothing,
        kind=nothing,
        name=nothing,
        namespace=nothing,
        resourceVersion=nothing,
        uid=nothing,
    )

    - apiVersion::String : API version of the referent.
    - fieldPath::String : If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \&quot;spec.containers{name}\&quot; (where \&quot;name\&quot; refers to the name of the container that triggered the event) or if no container name is specified \&quot;spec.containers[2]\&quot; (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.
    - kind::String : Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - name::String : Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    - namespace::String : Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/
    - resourceVersion::String : Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency
    - uid::String : UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ObjectReference <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    fieldPath::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    namespace::Union{Nothing, String} = nothing
    resourceVersion::Union{Nothing, String} = nothing
    uid::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1ObjectReference(apiVersion, fieldPath, kind, name, namespace, resourceVersion, uid, )
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("fieldPath"), fieldPath)
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("namespace"), namespace)
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("resourceVersion"), resourceVersion)
        OpenAPI.validate_property(IoK8sApiCoreV1ObjectReference, Symbol("uid"), uid)
        return new(apiVersion, fieldPath, kind, name, namespace, resourceVersion, uid, )
    end
end # type IoK8sApiCoreV1ObjectReference

const _property_types_IoK8sApiCoreV1ObjectReference = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("fieldPath")=>"String", Symbol("kind")=>"String", Symbol("name")=>"String", Symbol("namespace")=>"String", Symbol("resourceVersion")=>"String", Symbol("uid")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ObjectReference }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ObjectReference[name]))}

function check_required(o::IoK8sApiCoreV1ObjectReference)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ObjectReference }, name::Symbol, val)
end
