# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.PodCondition
PodCondition contains details for the current condition of this pod.

    IoK8sApiCoreV1PodCondition(;
        lastProbeTime=nothing,
        lastTransitionTime=nothing,
        message=nothing,
        reason=nothing,
        status=nothing,
        type=nothing,
    )

    - lastProbeTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - lastTransitionTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - message::String : Human-readable message indicating details about last transition.
    - reason::String : Unique, one-word, CamelCase reason for the condition&#39;s last transition.
    - status::String : Status is the status of the condition. Can be True, False, Unknown. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions
    - type::String : Type is the type of the condition. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions
"""
Base.@kwdef mutable struct IoK8sApiCoreV1PodCondition <: OpenAPI.APIModel
    lastProbeTime::Union{Nothing, ZonedDateTime} = nothing
    lastTransitionTime::Union{Nothing, ZonedDateTime} = nothing
    message::Union{Nothing, String} = nothing
    reason::Union{Nothing, String} = nothing
    status::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1PodCondition(lastProbeTime, lastTransitionTime, message, reason, status, type, )
        OpenAPI.validate_property(IoK8sApiCoreV1PodCondition, Symbol("lastProbeTime"), lastProbeTime)
        OpenAPI.validate_property(IoK8sApiCoreV1PodCondition, Symbol("lastTransitionTime"), lastTransitionTime)
        OpenAPI.validate_property(IoK8sApiCoreV1PodCondition, Symbol("message"), message)
        OpenAPI.validate_property(IoK8sApiCoreV1PodCondition, Symbol("reason"), reason)
        OpenAPI.validate_property(IoK8sApiCoreV1PodCondition, Symbol("status"), status)
        OpenAPI.validate_property(IoK8sApiCoreV1PodCondition, Symbol("type"), type)
        return new(lastProbeTime, lastTransitionTime, message, reason, status, type, )
    end
end # type IoK8sApiCoreV1PodCondition

const _property_types_IoK8sApiCoreV1PodCondition = Dict{Symbol,String}(Symbol("lastProbeTime")=>"ZonedDateTime", Symbol("lastTransitionTime")=>"ZonedDateTime", Symbol("message")=>"String", Symbol("reason")=>"String", Symbol("status")=>"String", Symbol("type")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1PodCondition }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1PodCondition[name]))}

function check_required(o::IoK8sApiCoreV1PodCondition)
    o.status === nothing && (return false)
    o.type === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1PodCondition }, name::Symbol, val)
    if name === Symbol("lastProbeTime")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1PodCondition", :format, val, "date-time")
    end
    if name === Symbol("lastTransitionTime")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1PodCondition", :format, val, "date-time")
    end
end
