# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.PodSecurityContext
PodSecurityContext holds pod-level security attributes and common container settings. Some fields are also present in container.securityContext.  Field values of container.securityContext take precedence over field values of PodSecurityContext.

    IoK8sApiCoreV1PodSecurityContext(;
        fsGroup=nothing,
        runAsGroup=nothing,
        runAsNonRoot=nothing,
        runAsUser=nothing,
        seLinuxOptions=nothing,
        supplementalGroups=nothing,
        sysctls=nothing,
        windowsOptions=nothing,
    )

    - fsGroup::Int64 : A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:  1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR&#39;d with rw-rw----  If unset, the Kubelet will not modify the ownership and permissions of any volume.
    - runAsGroup::Int64 : The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.
    - runAsNonRoot::Bool : Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
    - runAsUser::Int64 : The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.
    - seLinuxOptions::IoK8sApiCoreV1SELinuxOptions
    - supplementalGroups::Vector{Int64} : A list of groups applied to the first process run in each container, in addition to the container&#39;s primary GID.  If unspecified, no groups will be added to any container.
    - sysctls::Vector{IoK8sApiCoreV1Sysctl} : Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported sysctls (by the container runtime) might fail to launch.
    - windowsOptions::IoK8sApiCoreV1WindowsSecurityContextOptions
"""
Base.@kwdef mutable struct IoK8sApiCoreV1PodSecurityContext <: OpenAPI.APIModel
    fsGroup::Union{Nothing, Int64} = nothing
    runAsGroup::Union{Nothing, Int64} = nothing
    runAsNonRoot::Union{Nothing, Bool} = nothing
    runAsUser::Union{Nothing, Int64} = nothing
    seLinuxOptions = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1SELinuxOptions }
    supplementalGroups::Union{Nothing, Vector{Int64}} = nothing
    sysctls::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1Sysctl} }
    windowsOptions = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1WindowsSecurityContextOptions }

    function IoK8sApiCoreV1PodSecurityContext(fsGroup, runAsGroup, runAsNonRoot, runAsUser, seLinuxOptions, supplementalGroups, sysctls, windowsOptions, )
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("fsGroup"), fsGroup)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("runAsGroup"), runAsGroup)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("runAsNonRoot"), runAsNonRoot)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("runAsUser"), runAsUser)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("seLinuxOptions"), seLinuxOptions)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("supplementalGroups"), supplementalGroups)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("sysctls"), sysctls)
        OpenAPI.validate_property(IoK8sApiCoreV1PodSecurityContext, Symbol("windowsOptions"), windowsOptions)
        return new(fsGroup, runAsGroup, runAsNonRoot, runAsUser, seLinuxOptions, supplementalGroups, sysctls, windowsOptions, )
    end
end # type IoK8sApiCoreV1PodSecurityContext

const _property_types_IoK8sApiCoreV1PodSecurityContext = Dict{Symbol,String}(Symbol("fsGroup")=>"Int64", Symbol("runAsGroup")=>"Int64", Symbol("runAsNonRoot")=>"Bool", Symbol("runAsUser")=>"Int64", Symbol("seLinuxOptions")=>"IoK8sApiCoreV1SELinuxOptions", Symbol("supplementalGroups")=>"Vector{Int64}", Symbol("sysctls")=>"Vector{IoK8sApiCoreV1Sysctl}", Symbol("windowsOptions")=>"IoK8sApiCoreV1WindowsSecurityContextOptions", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1PodSecurityContext }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1PodSecurityContext[name]))}

function check_required(o::IoK8sApiCoreV1PodSecurityContext)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1PodSecurityContext }, name::Symbol, val)
    if name === Symbol("fsGroup")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1PodSecurityContext", :format, val, "int64")
    end
    if name === Symbol("runAsGroup")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1PodSecurityContext", :format, val, "int64")
    end
    if name === Symbol("runAsUser")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1PodSecurityContext", :format, val, "int64")
    end
end
