# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ReplicationControllerSpec
ReplicationControllerSpec is the specification of a replication controller.

    IoK8sApiCoreV1ReplicationControllerSpec(;
        minReadySeconds=nothing,
        replicas=nothing,
        selector=nothing,
        template=nothing,
    )

    - minReadySeconds::Int64 : Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)
    - replicas::Int64 : Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller
    - selector::Dict{String, String} : Selector is a label query over pods that should match the Replicas count. If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors
    - template::IoK8sApiCoreV1PodTemplateSpec
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ReplicationControllerSpec <: OpenAPI.APIModel
    minReadySeconds::Union{Nothing, Int64} = nothing
    replicas::Union{Nothing, Int64} = nothing
    selector::Union{Nothing, Dict{String, String}} = nothing
    template = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1PodTemplateSpec }

    function IoK8sApiCoreV1ReplicationControllerSpec(minReadySeconds, replicas, selector, template, )
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerSpec, Symbol("minReadySeconds"), minReadySeconds)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerSpec, Symbol("replicas"), replicas)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerSpec, Symbol("selector"), selector)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerSpec, Symbol("template"), template)
        return new(minReadySeconds, replicas, selector, template, )
    end
end # type IoK8sApiCoreV1ReplicationControllerSpec

const _property_types_IoK8sApiCoreV1ReplicationControllerSpec = Dict{Symbol,String}(Symbol("minReadySeconds")=>"Int64", Symbol("replicas")=>"Int64", Symbol("selector")=>"Dict{String, String}", Symbol("template")=>"IoK8sApiCoreV1PodTemplateSpec", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ReplicationControllerSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ReplicationControllerSpec[name]))}

function check_required(o::IoK8sApiCoreV1ReplicationControllerSpec)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ReplicationControllerSpec }, name::Symbol, val)
    if name === Symbol("minReadySeconds")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerSpec", :format, val, "int32")
    end
    if name === Symbol("replicas")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerSpec", :format, val, "int32")
    end
end
