# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ReplicationControllerStatus
ReplicationControllerStatus represents the current status of a replication controller.

    IoK8sApiCoreV1ReplicationControllerStatus(;
        availableReplicas=nothing,
        conditions=nothing,
        fullyLabeledReplicas=nothing,
        observedGeneration=nothing,
        readyReplicas=nothing,
        replicas=nothing,
    )

    - availableReplicas::Int64 : The number of available replicas (ready for at least minReadySeconds) for this replication controller.
    - conditions::Vector{IoK8sApiCoreV1ReplicationControllerCondition} : Represents the latest available observations of a replication controller&#39;s current state.
    - fullyLabeledReplicas::Int64 : The number of pods that have labels matching the labels of the pod template of the replication controller.
    - observedGeneration::Int64 : ObservedGeneration reflects the generation of the most recently observed replication controller.
    - readyReplicas::Int64 : The number of ready replicas for this replication controller.
    - replicas::Int64 : Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ReplicationControllerStatus <: OpenAPI.APIModel
    availableReplicas::Union{Nothing, Int64} = nothing
    conditions::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ReplicationControllerCondition} }
    fullyLabeledReplicas::Union{Nothing, Int64} = nothing
    observedGeneration::Union{Nothing, Int64} = nothing
    readyReplicas::Union{Nothing, Int64} = nothing
    replicas::Union{Nothing, Int64} = nothing

    function IoK8sApiCoreV1ReplicationControllerStatus(availableReplicas, conditions, fullyLabeledReplicas, observedGeneration, readyReplicas, replicas, )
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerStatus, Symbol("availableReplicas"), availableReplicas)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerStatus, Symbol("conditions"), conditions)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerStatus, Symbol("fullyLabeledReplicas"), fullyLabeledReplicas)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerStatus, Symbol("observedGeneration"), observedGeneration)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerStatus, Symbol("readyReplicas"), readyReplicas)
        OpenAPI.validate_property(IoK8sApiCoreV1ReplicationControllerStatus, Symbol("replicas"), replicas)
        return new(availableReplicas, conditions, fullyLabeledReplicas, observedGeneration, readyReplicas, replicas, )
    end
end # type IoK8sApiCoreV1ReplicationControllerStatus

const _property_types_IoK8sApiCoreV1ReplicationControllerStatus = Dict{Symbol,String}(Symbol("availableReplicas")=>"Int64", Symbol("conditions")=>"Vector{IoK8sApiCoreV1ReplicationControllerCondition}", Symbol("fullyLabeledReplicas")=>"Int64", Symbol("observedGeneration")=>"Int64", Symbol("readyReplicas")=>"Int64", Symbol("replicas")=>"Int64", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ReplicationControllerStatus }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ReplicationControllerStatus[name]))}

function check_required(o::IoK8sApiCoreV1ReplicationControllerStatus)
    o.replicas === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ReplicationControllerStatus }, name::Symbol, val)
    if name === Symbol("availableReplicas")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerStatus", :format, val, "int32")
    end
    if name === Symbol("fullyLabeledReplicas")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerStatus", :format, val, "int32")
    end
    if name === Symbol("observedGeneration")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerStatus", :format, val, "int64")
    end
    if name === Symbol("readyReplicas")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerStatus", :format, val, "int32")
    end
    if name === Symbol("replicas")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ReplicationControllerStatus", :format, val, "int32")
    end
end
