# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.SecretProjection
Adapts a secret into a projected volume.  The contents of the target Secret&#39;s Data field will be presented in a projected volume as files using the keys in the Data field as the file names. Note that this is identical to a secret volume source without the default mode.

    IoK8sApiCoreV1SecretProjection(;
        items=nothing,
        name=nothing,
        optional=nothing,
    )

    - items::Vector{IoK8sApiCoreV1KeyToPath} : If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the &#39;..&#39; path or start with &#39;..&#39;.
    - name::String : Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    - optional::Bool : Specify whether the Secret or its key must be defined
"""
Base.@kwdef mutable struct IoK8sApiCoreV1SecretProjection <: OpenAPI.APIModel
    items::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1KeyToPath} }
    name::Union{Nothing, String} = nothing
    optional::Union{Nothing, Bool} = nothing

    function IoK8sApiCoreV1SecretProjection(items, name, optional, )
        OpenAPI.validate_property(IoK8sApiCoreV1SecretProjection, Symbol("items"), items)
        OpenAPI.validate_property(IoK8sApiCoreV1SecretProjection, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApiCoreV1SecretProjection, Symbol("optional"), optional)
        return new(items, name, optional, )
    end
end # type IoK8sApiCoreV1SecretProjection

const _property_types_IoK8sApiCoreV1SecretProjection = Dict{Symbol,String}(Symbol("items")=>"Vector{IoK8sApiCoreV1KeyToPath}", Symbol("name")=>"String", Symbol("optional")=>"Bool", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1SecretProjection }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1SecretProjection[name]))}

function check_required(o::IoK8sApiCoreV1SecretProjection)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1SecretProjection }, name::Symbol, val)
end
