# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.SecretVolumeSource
Adapts a Secret into a volume.  The contents of the target Secret&#39;s Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.

    IoK8sApiCoreV1SecretVolumeSource(;
        defaultMode=nothing,
        items=nothing,
        optional=nothing,
        secretName=nothing,
    )

    - defaultMode::Int64 : Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.
    - items::Vector{IoK8sApiCoreV1KeyToPath} : If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the &#39;..&#39; path or start with &#39;..&#39;.
    - optional::Bool : Specify whether the Secret or its keys must be defined
    - secretName::String : Name of the secret in the pod&#39;s namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
"""
Base.@kwdef mutable struct IoK8sApiCoreV1SecretVolumeSource <: OpenAPI.APIModel
    defaultMode::Union{Nothing, Int64} = nothing
    items::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1KeyToPath} }
    optional::Union{Nothing, Bool} = nothing
    secretName::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1SecretVolumeSource(defaultMode, items, optional, secretName, )
        OpenAPI.validate_property(IoK8sApiCoreV1SecretVolumeSource, Symbol("defaultMode"), defaultMode)
        OpenAPI.validate_property(IoK8sApiCoreV1SecretVolumeSource, Symbol("items"), items)
        OpenAPI.validate_property(IoK8sApiCoreV1SecretVolumeSource, Symbol("optional"), optional)
        OpenAPI.validate_property(IoK8sApiCoreV1SecretVolumeSource, Symbol("secretName"), secretName)
        return new(defaultMode, items, optional, secretName, )
    end
end # type IoK8sApiCoreV1SecretVolumeSource

const _property_types_IoK8sApiCoreV1SecretVolumeSource = Dict{Symbol,String}(Symbol("defaultMode")=>"Int64", Symbol("items")=>"Vector{IoK8sApiCoreV1KeyToPath}", Symbol("optional")=>"Bool", Symbol("secretName")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1SecretVolumeSource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1SecretVolumeSource[name]))}

function check_required(o::IoK8sApiCoreV1SecretVolumeSource)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1SecretVolumeSource }, name::Symbol, val)
    if name === Symbol("defaultMode")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1SecretVolumeSource", :format, val, "int32")
    end
end
