# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.SecurityContext
SecurityContext holds security configuration that will be applied to a container. Some fields are present in both SecurityContext and PodSecurityContext.  When both are set, the values in SecurityContext take precedence.

    IoK8sApiCoreV1SecurityContext(;
        allowPrivilegeEscalation=nothing,
        capabilities=nothing,
        privileged=nothing,
        procMount=nothing,
        readOnlyRootFilesystem=nothing,
        runAsGroup=nothing,
        runAsNonRoot=nothing,
        runAsUser=nothing,
        seLinuxOptions=nothing,
        windowsOptions=nothing,
    )

    - allowPrivilegeEscalation::Bool : AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN
    - capabilities::IoK8sApiCoreV1Capabilities
    - privileged::Bool : Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false.
    - procMount::String : procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled.
    - readOnlyRootFilesystem::Bool : Whether this container has a read-only root filesystem. Default is false.
    - runAsGroup::Int64 : The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
    - runAsNonRoot::Bool : Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
    - runAsUser::Int64 : The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
    - seLinuxOptions::IoK8sApiCoreV1SELinuxOptions
    - windowsOptions::IoK8sApiCoreV1WindowsSecurityContextOptions
"""
Base.@kwdef mutable struct IoK8sApiCoreV1SecurityContext <: OpenAPI.APIModel
    allowPrivilegeEscalation::Union{Nothing, Bool} = nothing
    capabilities = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1Capabilities }
    privileged::Union{Nothing, Bool} = nothing
    procMount::Union{Nothing, String} = nothing
    readOnlyRootFilesystem::Union{Nothing, Bool} = nothing
    runAsGroup::Union{Nothing, Int64} = nothing
    runAsNonRoot::Union{Nothing, Bool} = nothing
    runAsUser::Union{Nothing, Int64} = nothing
    seLinuxOptions = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1SELinuxOptions }
    windowsOptions = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1WindowsSecurityContextOptions }

    function IoK8sApiCoreV1SecurityContext(allowPrivilegeEscalation, capabilities, privileged, procMount, readOnlyRootFilesystem, runAsGroup, runAsNonRoot, runAsUser, seLinuxOptions, windowsOptions, )
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("allowPrivilegeEscalation"), allowPrivilegeEscalation)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("capabilities"), capabilities)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("privileged"), privileged)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("procMount"), procMount)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("readOnlyRootFilesystem"), readOnlyRootFilesystem)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("runAsGroup"), runAsGroup)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("runAsNonRoot"), runAsNonRoot)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("runAsUser"), runAsUser)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("seLinuxOptions"), seLinuxOptions)
        OpenAPI.validate_property(IoK8sApiCoreV1SecurityContext, Symbol("windowsOptions"), windowsOptions)
        return new(allowPrivilegeEscalation, capabilities, privileged, procMount, readOnlyRootFilesystem, runAsGroup, runAsNonRoot, runAsUser, seLinuxOptions, windowsOptions, )
    end
end # type IoK8sApiCoreV1SecurityContext

const _property_types_IoK8sApiCoreV1SecurityContext = Dict{Symbol,String}(Symbol("allowPrivilegeEscalation")=>"Bool", Symbol("capabilities")=>"IoK8sApiCoreV1Capabilities", Symbol("privileged")=>"Bool", Symbol("procMount")=>"String", Symbol("readOnlyRootFilesystem")=>"Bool", Symbol("runAsGroup")=>"Int64", Symbol("runAsNonRoot")=>"Bool", Symbol("runAsUser")=>"Int64", Symbol("seLinuxOptions")=>"IoK8sApiCoreV1SELinuxOptions", Symbol("windowsOptions")=>"IoK8sApiCoreV1WindowsSecurityContextOptions", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1SecurityContext }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1SecurityContext[name]))}

function check_required(o::IoK8sApiCoreV1SecurityContext)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1SecurityContext }, name::Symbol, val)
    if name === Symbol("runAsGroup")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1SecurityContext", :format, val, "int64")
    end
    if name === Symbol("runAsUser")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1SecurityContext", :format, val, "int64")
    end
end
