# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ServiceAccount
ServiceAccount binds together: * a name, understood by users, and perhaps by peripheral systems, for an identity * a principal that can be authenticated and authorized * a set of secrets

    IoK8sApiCoreV1ServiceAccount(;
        apiVersion=nothing,
        automountServiceAccountToken=nothing,
        imagePullSecrets=nothing,
        kind=nothing,
        metadata=nothing,
        secrets=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - automountServiceAccountToken::Bool : AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted. Can be overridden at the pod level.
    - imagePullSecrets::Vector{IoK8sApiCoreV1LocalObjectReference} : ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - secrets::Vector{IoK8sApiCoreV1ObjectReference} : Secrets is the list of secrets allowed to be used by pods running using this ServiceAccount. More info: https://kubernetes.io/docs/concepts/configuration/secret
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ServiceAccount <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    automountServiceAccountToken::Union{Nothing, Bool} = nothing
    imagePullSecrets::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1LocalObjectReference} }
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    secrets::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ObjectReference} }

    function IoK8sApiCoreV1ServiceAccount(apiVersion, automountServiceAccountToken, imagePullSecrets, kind, metadata, secrets, )
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccount, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccount, Symbol("automountServiceAccountToken"), automountServiceAccountToken)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccount, Symbol("imagePullSecrets"), imagePullSecrets)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccount, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccount, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccount, Symbol("secrets"), secrets)
        return new(apiVersion, automountServiceAccountToken, imagePullSecrets, kind, metadata, secrets, )
    end
end # type IoK8sApiCoreV1ServiceAccount

const _property_types_IoK8sApiCoreV1ServiceAccount = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("automountServiceAccountToken")=>"Bool", Symbol("imagePullSecrets")=>"Vector{IoK8sApiCoreV1LocalObjectReference}", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("secrets")=>"Vector{IoK8sApiCoreV1ObjectReference}", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ServiceAccount }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ServiceAccount[name]))}

function check_required(o::IoK8sApiCoreV1ServiceAccount)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ServiceAccount }, name::Symbol, val)
end
