# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ServiceAccountTokenProjection
ServiceAccountTokenProjection represents a projected service account token volume. This projection can be used to insert a service account token into the pods runtime filesystem for use against APIs (Kubernetes API Server or otherwise).

    IoK8sApiCoreV1ServiceAccountTokenProjection(;
        audience=nothing,
        expirationSeconds=nothing,
        path=nothing,
    )

    - audience::String : Audience is the intended audience of the token. A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.
    - expirationSeconds::Int64 : ExpirationSeconds is the requested duration of validity of the service account token. As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.
    - path::String : Path is the path relative to the mount point of the file to project the token into.
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ServiceAccountTokenProjection <: OpenAPI.APIModel
    audience::Union{Nothing, String} = nothing
    expirationSeconds::Union{Nothing, Int64} = nothing
    path::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1ServiceAccountTokenProjection(audience, expirationSeconds, path, )
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccountTokenProjection, Symbol("audience"), audience)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccountTokenProjection, Symbol("expirationSeconds"), expirationSeconds)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceAccountTokenProjection, Symbol("path"), path)
        return new(audience, expirationSeconds, path, )
    end
end # type IoK8sApiCoreV1ServiceAccountTokenProjection

const _property_types_IoK8sApiCoreV1ServiceAccountTokenProjection = Dict{Symbol,String}(Symbol("audience")=>"String", Symbol("expirationSeconds")=>"Int64", Symbol("path")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ServiceAccountTokenProjection }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ServiceAccountTokenProjection[name]))}

function check_required(o::IoK8sApiCoreV1ServiceAccountTokenProjection)
    o.path === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ServiceAccountTokenProjection }, name::Symbol, val)
    if name === Symbol("expirationSeconds")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ServiceAccountTokenProjection", :format, val, "int64")
    end
end
