# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.ServiceSpec
ServiceSpec describes the attributes that a user creates on a service.

    IoK8sApiCoreV1ServiceSpec(;
        clusterIP=nothing,
        externalIPs=nothing,
        externalName=nothing,
        externalTrafficPolicy=nothing,
        healthCheckNodePort=nothing,
        ipFamily=nothing,
        loadBalancerIP=nothing,
        loadBalancerSourceRanges=nothing,
        ports=nothing,
        publishNotReadyAddresses=nothing,
        selector=nothing,
        sessionAffinity=nothing,
        sessionAffinityConfig=nothing,
        topologyKeys=nothing,
        type=nothing,
    )

    - clusterIP::String : clusterIP is the IP address of the service and is usually assigned randomly by the master. If an address is specified manually and is not in use by others, it will be allocated to the service; otherwise, creation of the service will fail. This field can not be changed through updates. Valid values are \&quot;None\&quot;, empty string (\&quot;\&quot;), or a valid IP address. \&quot;None\&quot; can be specified for headless services when proxying is not required. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
    - externalIPs::Vector{String} : externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.  These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.
    - externalName::String : externalName is the external reference that kubedns or equivalent will return as a CNAME record for this service. No proxying will be involved. Must be a valid RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires Type to be ExternalName.
    - externalTrafficPolicy::String : externalTrafficPolicy denotes if this Service desires to route external traffic to node-local or cluster-wide endpoints. \&quot;Local\&quot; preserves the client source IP and avoids a second hop for LoadBalancer and Nodeport type services, but risks potentially imbalanced traffic spreading. \&quot;Cluster\&quot; obscures the client source IP and may cause a second hop to another node, but should have good overall load-spreading.
    - healthCheckNodePort::Int64 : healthCheckNodePort specifies the healthcheck nodePort for the service. If not specified, HealthCheckNodePort is created by the service api backend with the allocated nodePort. Will use user-specified nodePort value if specified by the client. Only effects when Type is set to LoadBalancer and ExternalTrafficPolicy is set to Local.
    - ipFamily::String : ipFamily specifies whether this Service has a preference for a particular IP family (e.g. IPv4 vs. IPv6).  If a specific IP family is requested, the clusterIP field will be allocated from that family, if it is available in the cluster.  If no IP family is requested, the cluster&#39;s primary IP family will be used. Other IP fields (loadBalancerIP, loadBalancerSourceRanges, externalIPs) and controllers which allocate external load-balancers should use the same IP family.  Endpoints for this Service will be of this family.  This field is immutable after creation. Assigning a ServiceIPFamily not available in the cluster (e.g. IPv6 in IPv4 only cluster) is an error condition and will fail during clusterIP assignment.
    - loadBalancerIP::String : Only applies to Service Type: LoadBalancer LoadBalancer will get created with the IP specified in this field. This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature.
    - loadBalancerSourceRanges::Vector{String} : If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature.\&quot; More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/
    - ports::Vector{IoK8sApiCoreV1ServicePort} : The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
    - publishNotReadyAddresses::Bool : publishNotReadyAddresses, when set to true, indicates that DNS implementations must publish the notReadyAddresses of subsets for the Endpoints associated with the Service. The default value is false. The primary use case for setting this field is to use a StatefulSet&#39;s Headless Service to propagate SRV records for its Pods without respect to their readiness for purpose of peer discovery.
    - selector::Dict{String, String} : Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/
    - sessionAffinity::String : Supports \&quot;ClientIP\&quot; and \&quot;None\&quot;. Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
    - sessionAffinityConfig::IoK8sApiCoreV1SessionAffinityConfig
    - topologyKeys::Vector{String} : topologyKeys is a preference-order list of topology keys which implementations of services should use to preferentially sort endpoints when accessing this Service, it can not be used at the same time as externalTrafficPolicy&#x3D;Local. Topology keys must be valid label keys and at most 16 keys may be specified. Endpoints are chosen based on the first topology key with available backends. If this field is specified and all entries have no backends that match the topology of the client, the service has no backends for that client and connections should fail. The special value \&quot;*\&quot; may be used to mean \&quot;any topology\&quot;. This catch-all value, if used, only makes sense as the last value in the list. If this is not specified or empty, no topology constraints will be applied.
    - type::String : type determines how the Service is exposed. Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. \&quot;ExternalName\&quot; maps to the specified externalName. \&quot;ClusterIP\&quot; allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object. If clusterIP is \&quot;None\&quot;, no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a stable IP. \&quot;NodePort\&quot; builds on ClusterIP and allocates a port on every node which routes to the clusterIP. \&quot;LoadBalancer\&quot; builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the clusterIP. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types
"""
Base.@kwdef mutable struct IoK8sApiCoreV1ServiceSpec <: OpenAPI.APIModel
    clusterIP::Union{Nothing, String} = nothing
    externalIPs::Union{Nothing, Vector{String}} = nothing
    externalName::Union{Nothing, String} = nothing
    externalTrafficPolicy::Union{Nothing, String} = nothing
    healthCheckNodePort::Union{Nothing, Int64} = nothing
    ipFamily::Union{Nothing, String} = nothing
    loadBalancerIP::Union{Nothing, String} = nothing
    loadBalancerSourceRanges::Union{Nothing, Vector{String}} = nothing
    ports::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ServicePort} }
    publishNotReadyAddresses::Union{Nothing, Bool} = nothing
    selector::Union{Nothing, Dict{String, String}} = nothing
    sessionAffinity::Union{Nothing, String} = nothing
    sessionAffinityConfig = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1SessionAffinityConfig }
    topologyKeys::Union{Nothing, Vector{String}} = nothing
    type::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1ServiceSpec(clusterIP, externalIPs, externalName, externalTrafficPolicy, healthCheckNodePort, ipFamily, loadBalancerIP, loadBalancerSourceRanges, ports, publishNotReadyAddresses, selector, sessionAffinity, sessionAffinityConfig, topologyKeys, type, )
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("clusterIP"), clusterIP)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("externalIPs"), externalIPs)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("externalName"), externalName)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("externalTrafficPolicy"), externalTrafficPolicy)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("healthCheckNodePort"), healthCheckNodePort)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("ipFamily"), ipFamily)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("loadBalancerIP"), loadBalancerIP)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("loadBalancerSourceRanges"), loadBalancerSourceRanges)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("ports"), ports)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("publishNotReadyAddresses"), publishNotReadyAddresses)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("selector"), selector)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("sessionAffinity"), sessionAffinity)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("sessionAffinityConfig"), sessionAffinityConfig)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("topologyKeys"), topologyKeys)
        OpenAPI.validate_property(IoK8sApiCoreV1ServiceSpec, Symbol("type"), type)
        return new(clusterIP, externalIPs, externalName, externalTrafficPolicy, healthCheckNodePort, ipFamily, loadBalancerIP, loadBalancerSourceRanges, ports, publishNotReadyAddresses, selector, sessionAffinity, sessionAffinityConfig, topologyKeys, type, )
    end
end # type IoK8sApiCoreV1ServiceSpec

const _property_types_IoK8sApiCoreV1ServiceSpec = Dict{Symbol,String}(Symbol("clusterIP")=>"String", Symbol("externalIPs")=>"Vector{String}", Symbol("externalName")=>"String", Symbol("externalTrafficPolicy")=>"String", Symbol("healthCheckNodePort")=>"Int64", Symbol("ipFamily")=>"String", Symbol("loadBalancerIP")=>"String", Symbol("loadBalancerSourceRanges")=>"Vector{String}", Symbol("ports")=>"Vector{IoK8sApiCoreV1ServicePort}", Symbol("publishNotReadyAddresses")=>"Bool", Symbol("selector")=>"Dict{String, String}", Symbol("sessionAffinity")=>"String", Symbol("sessionAffinityConfig")=>"IoK8sApiCoreV1SessionAffinityConfig", Symbol("topologyKeys")=>"Vector{String}", Symbol("type")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1ServiceSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1ServiceSpec[name]))}

function check_required(o::IoK8sApiCoreV1ServiceSpec)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1ServiceSpec }, name::Symbol, val)
    if name === Symbol("healthCheckNodePort")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1ServiceSpec", :format, val, "int32")
    end
end
