# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.Toleration
The pod this Toleration is attached to tolerates any taint that matches the triple &lt;key,value,effect&gt; using the matching operator &lt;operator&gt;.

    IoK8sApiCoreV1Toleration(;
        effect=nothing,
        key=nothing,
        operator=nothing,
        tolerationSeconds=nothing,
        value=nothing,
    )

    - effect::String : Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.
    - key::String : Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.
    - operator::String : Operator represents a key&#39;s relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.
    - tolerationSeconds::Int64 : TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.
    - value::String : Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.
"""
Base.@kwdef mutable struct IoK8sApiCoreV1Toleration <: OpenAPI.APIModel
    effect::Union{Nothing, String} = nothing
    key::Union{Nothing, String} = nothing
    operator::Union{Nothing, String} = nothing
    tolerationSeconds::Union{Nothing, Int64} = nothing
    value::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1Toleration(effect, key, operator, tolerationSeconds, value, )
        OpenAPI.validate_property(IoK8sApiCoreV1Toleration, Symbol("effect"), effect)
        OpenAPI.validate_property(IoK8sApiCoreV1Toleration, Symbol("key"), key)
        OpenAPI.validate_property(IoK8sApiCoreV1Toleration, Symbol("operator"), operator)
        OpenAPI.validate_property(IoK8sApiCoreV1Toleration, Symbol("tolerationSeconds"), tolerationSeconds)
        OpenAPI.validate_property(IoK8sApiCoreV1Toleration, Symbol("value"), value)
        return new(effect, key, operator, tolerationSeconds, value, )
    end
end # type IoK8sApiCoreV1Toleration

const _property_types_IoK8sApiCoreV1Toleration = Dict{Symbol,String}(Symbol("effect")=>"String", Symbol("key")=>"String", Symbol("operator")=>"String", Symbol("tolerationSeconds")=>"Int64", Symbol("value")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1Toleration }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1Toleration[name]))}

function check_required(o::IoK8sApiCoreV1Toleration)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1Toleration }, name::Symbol, val)
    if name === Symbol("tolerationSeconds")
        OpenAPI.validate_param(name, "IoK8sApiCoreV1Toleration", :format, val, "int64")
    end
end
