# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.core.v1.WindowsSecurityContextOptions
WindowsSecurityContextOptions contain Windows-specific options and credentials.

    IoK8sApiCoreV1WindowsSecurityContextOptions(;
        gmsaCredentialSpec=nothing,
        gmsaCredentialSpecName=nothing,
        runAsUserName=nothing,
    )

    - gmsaCredentialSpec::String : GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag.
    - gmsaCredentialSpecName::String : GMSACredentialSpecName is the name of the GMSA credential spec to use. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag.
    - runAsUserName::String : The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. This field is beta-level and may be disabled with the WindowsRunAsUserName feature flag.
"""
Base.@kwdef mutable struct IoK8sApiCoreV1WindowsSecurityContextOptions <: OpenAPI.APIModel
    gmsaCredentialSpec::Union{Nothing, String} = nothing
    gmsaCredentialSpecName::Union{Nothing, String} = nothing
    runAsUserName::Union{Nothing, String} = nothing

    function IoK8sApiCoreV1WindowsSecurityContextOptions(gmsaCredentialSpec, gmsaCredentialSpecName, runAsUserName, )
        OpenAPI.validate_property(IoK8sApiCoreV1WindowsSecurityContextOptions, Symbol("gmsaCredentialSpec"), gmsaCredentialSpec)
        OpenAPI.validate_property(IoK8sApiCoreV1WindowsSecurityContextOptions, Symbol("gmsaCredentialSpecName"), gmsaCredentialSpecName)
        OpenAPI.validate_property(IoK8sApiCoreV1WindowsSecurityContextOptions, Symbol("runAsUserName"), runAsUserName)
        return new(gmsaCredentialSpec, gmsaCredentialSpecName, runAsUserName, )
    end
end # type IoK8sApiCoreV1WindowsSecurityContextOptions

const _property_types_IoK8sApiCoreV1WindowsSecurityContextOptions = Dict{Symbol,String}(Symbol("gmsaCredentialSpec")=>"String", Symbol("gmsaCredentialSpecName")=>"String", Symbol("runAsUserName")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiCoreV1WindowsSecurityContextOptions }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1WindowsSecurityContextOptions[name]))}

function check_required(o::IoK8sApiCoreV1WindowsSecurityContextOptions)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiCoreV1WindowsSecurityContextOptions }, name::Symbol, val)
end
