# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.discovery.v1beta1.EndpointSlice
EndpointSlice represents a subset of the endpoints that implement a service. For a given service there may be multiple EndpointSlice objects, selected by labels, which must be joined to produce the full set of endpoints.

    IoK8sApiDiscoveryV1beta1EndpointSlice(;
        addressType=nothing,
        apiVersion=nothing,
        endpoints=nothing,
        kind=nothing,
        metadata=nothing,
        ports=nothing,
    )

    - addressType::String : addressType specifies the type of address carried by this EndpointSlice. All addresses in this slice must be the same type. This field is immutable after creation. The following address types are currently supported: * IPv4: Represents an IPv4 Address. * IPv6: Represents an IPv6 Address. * FQDN: Represents a Fully Qualified Domain Name.
    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - endpoints::Vector{IoK8sApiDiscoveryV1beta1Endpoint} : endpoints is a list of unique endpoints in this slice. Each slice may include a maximum of 1000 endpoints.
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - ports::Vector{IoK8sApiDiscoveryV1beta1EndpointPort} : ports specifies the list of network ports exposed by each endpoint in this slice. Each port must have a unique name. When ports is empty, it indicates that there are no defined ports. When a port is defined with a nil port value, it indicates \&quot;all ports\&quot;. Each slice may include a maximum of 100 ports.
"""
Base.@kwdef mutable struct IoK8sApiDiscoveryV1beta1EndpointSlice <: OpenAPI.APIModel
    addressType::Union{Nothing, String} = nothing
    apiVersion::Union{Nothing, String} = nothing
    endpoints::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiDiscoveryV1beta1Endpoint} }
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    ports::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiDiscoveryV1beta1EndpointPort} }

    function IoK8sApiDiscoveryV1beta1EndpointSlice(addressType, apiVersion, endpoints, kind, metadata, ports, )
        OpenAPI.validate_property(IoK8sApiDiscoveryV1beta1EndpointSlice, Symbol("addressType"), addressType)
        OpenAPI.validate_property(IoK8sApiDiscoveryV1beta1EndpointSlice, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiDiscoveryV1beta1EndpointSlice, Symbol("endpoints"), endpoints)
        OpenAPI.validate_property(IoK8sApiDiscoveryV1beta1EndpointSlice, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiDiscoveryV1beta1EndpointSlice, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiDiscoveryV1beta1EndpointSlice, Symbol("ports"), ports)
        return new(addressType, apiVersion, endpoints, kind, metadata, ports, )
    end
end # type IoK8sApiDiscoveryV1beta1EndpointSlice

const _property_types_IoK8sApiDiscoveryV1beta1EndpointSlice = Dict{Symbol,String}(Symbol("addressType")=>"String", Symbol("apiVersion")=>"String", Symbol("endpoints")=>"Vector{IoK8sApiDiscoveryV1beta1Endpoint}", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("ports")=>"Vector{IoK8sApiDiscoveryV1beta1EndpointPort}", )
OpenAPI.property_type(::Type{ IoK8sApiDiscoveryV1beta1EndpointSlice }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiDiscoveryV1beta1EndpointSlice[name]))}

function check_required(o::IoK8sApiDiscoveryV1beta1EndpointSlice)
    o.addressType === nothing && (return false)
    o.endpoints === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiDiscoveryV1beta1EndpointSlice }, name::Symbol, val)
end
