# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.extensions.v1beta1.DaemonSetSpec
DaemonSetSpec is the specification of a daemon set.

    IoK8sApiExtensionsV1beta1DaemonSetSpec(;
        minReadySeconds=nothing,
        revisionHistoryLimit=nothing,
        selector=nothing,
        template=nothing,
        templateGeneration=nothing,
        updateStrategy=nothing,
    )

    - minReadySeconds::Int64 : The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).
    - revisionHistoryLimit::Int64 : The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.
    - selector::IoK8sApimachineryPkgApisMetaV1LabelSelector
    - template::IoK8sApiCoreV1PodTemplateSpec
    - templateGeneration::Int64 : DEPRECATED. A sequence number representing a specific generation of the template. Populated by the system. It can be set only during the creation.
    - updateStrategy::IoK8sApiExtensionsV1beta1DaemonSetUpdateStrategy
"""
Base.@kwdef mutable struct IoK8sApiExtensionsV1beta1DaemonSetSpec <: OpenAPI.APIModel
    minReadySeconds::Union{Nothing, Int64} = nothing
    revisionHistoryLimit::Union{Nothing, Int64} = nothing
    selector = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1LabelSelector }
    template = nothing # spec type: Union{ Nothing, IoK8sApiCoreV1PodTemplateSpec }
    templateGeneration::Union{Nothing, Int64} = nothing
    updateStrategy = nothing # spec type: Union{ Nothing, IoK8sApiExtensionsV1beta1DaemonSetUpdateStrategy }

    function IoK8sApiExtensionsV1beta1DaemonSetSpec(minReadySeconds, revisionHistoryLimit, selector, template, templateGeneration, updateStrategy, )
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DaemonSetSpec, Symbol("minReadySeconds"), minReadySeconds)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DaemonSetSpec, Symbol("revisionHistoryLimit"), revisionHistoryLimit)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DaemonSetSpec, Symbol("selector"), selector)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DaemonSetSpec, Symbol("template"), template)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DaemonSetSpec, Symbol("templateGeneration"), templateGeneration)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DaemonSetSpec, Symbol("updateStrategy"), updateStrategy)
        return new(minReadySeconds, revisionHistoryLimit, selector, template, templateGeneration, updateStrategy, )
    end
end # type IoK8sApiExtensionsV1beta1DaemonSetSpec

const _property_types_IoK8sApiExtensionsV1beta1DaemonSetSpec = Dict{Symbol,String}(Symbol("minReadySeconds")=>"Int64", Symbol("revisionHistoryLimit")=>"Int64", Symbol("selector")=>"IoK8sApimachineryPkgApisMetaV1LabelSelector", Symbol("template")=>"IoK8sApiCoreV1PodTemplateSpec", Symbol("templateGeneration")=>"Int64", Symbol("updateStrategy")=>"IoK8sApiExtensionsV1beta1DaemonSetUpdateStrategy", )
OpenAPI.property_type(::Type{ IoK8sApiExtensionsV1beta1DaemonSetSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiExtensionsV1beta1DaemonSetSpec[name]))}

function check_required(o::IoK8sApiExtensionsV1beta1DaemonSetSpec)
    o.template === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiExtensionsV1beta1DaemonSetSpec }, name::Symbol, val)
    if name === Symbol("minReadySeconds")
        OpenAPI.validate_param(name, "IoK8sApiExtensionsV1beta1DaemonSetSpec", :format, val, "int32")
    end
    if name === Symbol("revisionHistoryLimit")
        OpenAPI.validate_param(name, "IoK8sApiExtensionsV1beta1DaemonSetSpec", :format, val, "int32")
    end
    if name === Symbol("templateGeneration")
        OpenAPI.validate_param(name, "IoK8sApiExtensionsV1beta1DaemonSetSpec", :format, val, "int64")
    end
end
