# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.extensions.v1beta1.DeploymentCondition
DeploymentCondition describes the state of a deployment at a certain point.

    IoK8sApiExtensionsV1beta1DeploymentCondition(;
        lastTransitionTime=nothing,
        lastUpdateTime=nothing,
        message=nothing,
        reason=nothing,
        status=nothing,
        type=nothing,
    )

    - lastTransitionTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - lastUpdateTime::ZonedDateTime : Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
    - message::String : A human readable message indicating details about the transition.
    - reason::String : The reason for the condition&#39;s last transition.
    - status::String : Status of the condition, one of True, False, Unknown.
    - type::String : Type of deployment condition.
"""
Base.@kwdef mutable struct IoK8sApiExtensionsV1beta1DeploymentCondition <: OpenAPI.APIModel
    lastTransitionTime::Union{Nothing, ZonedDateTime} = nothing
    lastUpdateTime::Union{Nothing, ZonedDateTime} = nothing
    message::Union{Nothing, String} = nothing
    reason::Union{Nothing, String} = nothing
    status::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing

    function IoK8sApiExtensionsV1beta1DeploymentCondition(lastTransitionTime, lastUpdateTime, message, reason, status, type, )
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DeploymentCondition, Symbol("lastTransitionTime"), lastTransitionTime)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DeploymentCondition, Symbol("lastUpdateTime"), lastUpdateTime)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DeploymentCondition, Symbol("message"), message)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DeploymentCondition, Symbol("reason"), reason)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DeploymentCondition, Symbol("status"), status)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1DeploymentCondition, Symbol("type"), type)
        return new(lastTransitionTime, lastUpdateTime, message, reason, status, type, )
    end
end # type IoK8sApiExtensionsV1beta1DeploymentCondition

const _property_types_IoK8sApiExtensionsV1beta1DeploymentCondition = Dict{Symbol,String}(Symbol("lastTransitionTime")=>"ZonedDateTime", Symbol("lastUpdateTime")=>"ZonedDateTime", Symbol("message")=>"String", Symbol("reason")=>"String", Symbol("status")=>"String", Symbol("type")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApiExtensionsV1beta1DeploymentCondition }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiExtensionsV1beta1DeploymentCondition[name]))}

function check_required(o::IoK8sApiExtensionsV1beta1DeploymentCondition)
    o.status === nothing && (return false)
    o.type === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiExtensionsV1beta1DeploymentCondition }, name::Symbol, val)
    if name === Symbol("lastTransitionTime")
        OpenAPI.validate_param(name, "IoK8sApiExtensionsV1beta1DeploymentCondition", :format, val, "date-time")
    end
    if name === Symbol("lastUpdateTime")
        OpenAPI.validate_param(name, "IoK8sApiExtensionsV1beta1DeploymentCondition", :format, val, "date-time")
    end
end
