# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.extensions.v1beta1.Ingress
Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend. An Ingress can be configured to give services externally-reachable urls, load balance traffic, terminate SSL, offer name based virtual hosting etc. DEPRECATED - This group version of Ingress is deprecated by networking.k8s.io/v1beta1 Ingress. See the release notes for more information.

    IoK8sApiExtensionsV1beta1Ingress(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiExtensionsV1beta1IngressSpec
    - status::IoK8sApiExtensionsV1beta1IngressStatus
"""
Base.@kwdef mutable struct IoK8sApiExtensionsV1beta1Ingress <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiExtensionsV1beta1IngressSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiExtensionsV1beta1IngressStatus }

    function IoK8sApiExtensionsV1beta1Ingress(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1Ingress, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1Ingress, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1Ingress, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1Ingress, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiExtensionsV1beta1Ingress, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiExtensionsV1beta1Ingress

const _property_types_IoK8sApiExtensionsV1beta1Ingress = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiExtensionsV1beta1IngressSpec", Symbol("status")=>"IoK8sApiExtensionsV1beta1IngressStatus", )
OpenAPI.property_type(::Type{ IoK8sApiExtensionsV1beta1Ingress }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiExtensionsV1beta1Ingress[name]))}

function check_required(o::IoK8sApiExtensionsV1beta1Ingress)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiExtensionsV1beta1Ingress }, name::Symbol, val)
end
