# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.flowcontrol.v1alpha1.FlowSchema
FlowSchema defines the schema of a group of flows. Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a \&quot;flow distinguisher\&quot;.

    IoK8sApiFlowcontrolV1alpha1FlowSchema(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiFlowcontrolV1alpha1FlowSchemaSpec
    - status::IoK8sApiFlowcontrolV1alpha1FlowSchemaStatus
"""
Base.@kwdef mutable struct IoK8sApiFlowcontrolV1alpha1FlowSchema <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiFlowcontrolV1alpha1FlowSchemaSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiFlowcontrolV1alpha1FlowSchemaStatus }

    function IoK8sApiFlowcontrolV1alpha1FlowSchema(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1FlowSchema, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1FlowSchema, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1FlowSchema, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1FlowSchema, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1FlowSchema, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiFlowcontrolV1alpha1FlowSchema

const _property_types_IoK8sApiFlowcontrolV1alpha1FlowSchema = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiFlowcontrolV1alpha1FlowSchemaSpec", Symbol("status")=>"IoK8sApiFlowcontrolV1alpha1FlowSchemaStatus", )
OpenAPI.property_type(::Type{ IoK8sApiFlowcontrolV1alpha1FlowSchema }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiFlowcontrolV1alpha1FlowSchema[name]))}

function check_required(o::IoK8sApiFlowcontrolV1alpha1FlowSchema)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiFlowcontrolV1alpha1FlowSchema }, name::Symbol, val)
end
