# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.flowcontrol.v1alpha1.NonResourcePolicyRule
NonResourcePolicyRule is a predicate that matches non-resource requests according to their verb and the target non-resource URL. A NonResourcePolicyRule matches a request if and only if both (a) at least one member of verbs matches the request and (b) at least one member of nonResourceURLs matches the request.

    IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule(;
        nonResourceURLs=nothing,
        verbs=nothing,
    )

    - nonResourceURLs::Vector{String} : &#x60;nonResourceURLs&#x60; is a set of url prefixes that a user should have access to and may not be empty. For example:   - \&quot;/healthz\&quot; is legal   - \&quot;/hea*\&quot; is illegal   - \&quot;/hea\&quot; is legal but matches nothing   - \&quot;/hea/*\&quot; also matches nothing   - \&quot;/healthz/*\&quot; matches all per-component health checks. \&quot;*\&quot; matches all non-resource urls. if it is present, it must be the only entry. Required.
    - verbs::Vector{String} : &#x60;verbs&#x60; is a list of matching verbs and may not be empty. \&quot;*\&quot; matches all verbs. If it is present, it must be the only entry. Required.
"""
Base.@kwdef mutable struct IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule <: OpenAPI.APIModel
    nonResourceURLs::Union{Nothing, Vector{String}} = nothing
    verbs::Union{Nothing, Vector{String}} = nothing

    function IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule(nonResourceURLs, verbs, )
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule, Symbol("nonResourceURLs"), nonResourceURLs)
        OpenAPI.validate_property(IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule, Symbol("verbs"), verbs)
        return new(nonResourceURLs, verbs, )
    end
end # type IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule

const _property_types_IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule = Dict{Symbol,String}(Symbol("nonResourceURLs")=>"Vector{String}", Symbol("verbs")=>"Vector{String}", )
OpenAPI.property_type(::Type{ IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule[name]))}

function check_required(o::IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule)
    o.nonResourceURLs === nothing && (return false)
    o.verbs === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiFlowcontrolV1alpha1NonResourcePolicyRule }, name::Symbol, val)
end
