# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.node.v1alpha1.RuntimeClassSpec
RuntimeClassSpec is a specification of a RuntimeClass. It contains parameters that are required to describe the RuntimeClass to the Container Runtime Interface (CRI) implementation, as well as any other components that need to understand how the pod will be run. The RuntimeClassSpec is immutable.

    IoK8sApiNodeV1alpha1RuntimeClassSpec(;
        overhead=nothing,
        runtimeHandler=nothing,
        scheduling=nothing,
    )

    - overhead::IoK8sApiNodeV1alpha1Overhead
    - runtimeHandler::String : RuntimeHandler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class. The possible values are specific to the node &amp; CRI configuration.  It is assumed that all handlers are available on every node, and handlers of the same name are equivalent on every node. For example, a handler called \&quot;runc\&quot; might specify that the runc OCI runtime (using native Linux containers) will be used to run the containers in a pod. The RuntimeHandler must conform to the DNS Label (RFC 1123) requirements and is immutable.
    - scheduling::IoK8sApiNodeV1alpha1Scheduling
"""
Base.@kwdef mutable struct IoK8sApiNodeV1alpha1RuntimeClassSpec <: OpenAPI.APIModel
    overhead = nothing # spec type: Union{ Nothing, IoK8sApiNodeV1alpha1Overhead }
    runtimeHandler::Union{Nothing, String} = nothing
    scheduling = nothing # spec type: Union{ Nothing, IoK8sApiNodeV1alpha1Scheduling }

    function IoK8sApiNodeV1alpha1RuntimeClassSpec(overhead, runtimeHandler, scheduling, )
        OpenAPI.validate_property(IoK8sApiNodeV1alpha1RuntimeClassSpec, Symbol("overhead"), overhead)
        OpenAPI.validate_property(IoK8sApiNodeV1alpha1RuntimeClassSpec, Symbol("runtimeHandler"), runtimeHandler)
        OpenAPI.validate_property(IoK8sApiNodeV1alpha1RuntimeClassSpec, Symbol("scheduling"), scheduling)
        return new(overhead, runtimeHandler, scheduling, )
    end
end # type IoK8sApiNodeV1alpha1RuntimeClassSpec

const _property_types_IoK8sApiNodeV1alpha1RuntimeClassSpec = Dict{Symbol,String}(Symbol("overhead")=>"IoK8sApiNodeV1alpha1Overhead", Symbol("runtimeHandler")=>"String", Symbol("scheduling")=>"IoK8sApiNodeV1alpha1Scheduling", )
OpenAPI.property_type(::Type{ IoK8sApiNodeV1alpha1RuntimeClassSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiNodeV1alpha1RuntimeClassSpec[name]))}

function check_required(o::IoK8sApiNodeV1alpha1RuntimeClassSpec)
    o.runtimeHandler === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiNodeV1alpha1RuntimeClassSpec }, name::Symbol, val)
end
