# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.node.v1alpha1.Scheduling
Scheduling specifies the scheduling constraints for nodes supporting a RuntimeClass.

    IoK8sApiNodeV1alpha1Scheduling(;
        nodeSelector=nothing,
        tolerations=nothing,
    )

    - nodeSelector::Dict{String, String} : nodeSelector lists labels that must be present on nodes that support this RuntimeClass. Pods using this RuntimeClass can only be scheduled to a node matched by this selector. The RuntimeClass nodeSelector is merged with a pod&#39;s existing nodeSelector. Any conflicts will cause the pod to be rejected in admission.
    - tolerations::Vector{IoK8sApiCoreV1Toleration} : tolerations are appended (excluding duplicates) to pods running with this RuntimeClass during admission, effectively unioning the set of nodes tolerated by the pod and the RuntimeClass.
"""
Base.@kwdef mutable struct IoK8sApiNodeV1alpha1Scheduling <: OpenAPI.APIModel
    nodeSelector::Union{Nothing, Dict{String, String}} = nothing
    tolerations::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1Toleration} }

    function IoK8sApiNodeV1alpha1Scheduling(nodeSelector, tolerations, )
        OpenAPI.validate_property(IoK8sApiNodeV1alpha1Scheduling, Symbol("nodeSelector"), nodeSelector)
        OpenAPI.validate_property(IoK8sApiNodeV1alpha1Scheduling, Symbol("tolerations"), tolerations)
        return new(nodeSelector, tolerations, )
    end
end # type IoK8sApiNodeV1alpha1Scheduling

const _property_types_IoK8sApiNodeV1alpha1Scheduling = Dict{Symbol,String}(Symbol("nodeSelector")=>"Dict{String, String}", Symbol("tolerations")=>"Vector{IoK8sApiCoreV1Toleration}", )
OpenAPI.property_type(::Type{ IoK8sApiNodeV1alpha1Scheduling }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiNodeV1alpha1Scheduling[name]))}

function check_required(o::IoK8sApiNodeV1alpha1Scheduling)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiNodeV1alpha1Scheduling }, name::Symbol, val)
end
