# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.node.v1beta1.RuntimeClass
RuntimeClass defines a class of container runtime supported in the cluster. The RuntimeClass is used to determine which container runtime is used to run all containers in a pod. RuntimeClasses are (currently) manually defined by a user or cluster provisioner, and referenced in the PodSpec. The Kubelet is responsible for resolving the RuntimeClassName reference before running the pod.  For more details, see https://git.k8s.io/enhancements/keps/sig-node/runtime-class.md

    IoK8sApiNodeV1beta1RuntimeClass(;
        apiVersion=nothing,
        handler=nothing,
        kind=nothing,
        metadata=nothing,
        overhead=nothing,
        scheduling=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - handler::String : Handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class. The possible values are specific to the node &amp; CRI configuration.  It is assumed that all handlers are available on every node, and handlers of the same name are equivalent on every node. For example, a handler called \&quot;runc\&quot; might specify that the runc OCI runtime (using native Linux containers) will be used to run the containers in a pod. The Handler must conform to the DNS Label (RFC 1123) requirements, and is immutable.
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - overhead::IoK8sApiNodeV1beta1Overhead
    - scheduling::IoK8sApiNodeV1beta1Scheduling
"""
Base.@kwdef mutable struct IoK8sApiNodeV1beta1RuntimeClass <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    handler::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    overhead = nothing # spec type: Union{ Nothing, IoK8sApiNodeV1beta1Overhead }
    scheduling = nothing # spec type: Union{ Nothing, IoK8sApiNodeV1beta1Scheduling }

    function IoK8sApiNodeV1beta1RuntimeClass(apiVersion, handler, kind, metadata, overhead, scheduling, )
        OpenAPI.validate_property(IoK8sApiNodeV1beta1RuntimeClass, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiNodeV1beta1RuntimeClass, Symbol("handler"), handler)
        OpenAPI.validate_property(IoK8sApiNodeV1beta1RuntimeClass, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiNodeV1beta1RuntimeClass, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiNodeV1beta1RuntimeClass, Symbol("overhead"), overhead)
        OpenAPI.validate_property(IoK8sApiNodeV1beta1RuntimeClass, Symbol("scheduling"), scheduling)
        return new(apiVersion, handler, kind, metadata, overhead, scheduling, )
    end
end # type IoK8sApiNodeV1beta1RuntimeClass

const _property_types_IoK8sApiNodeV1beta1RuntimeClass = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("handler")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("overhead")=>"IoK8sApiNodeV1beta1Overhead", Symbol("scheduling")=>"IoK8sApiNodeV1beta1Scheduling", )
OpenAPI.property_type(::Type{ IoK8sApiNodeV1beta1RuntimeClass }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiNodeV1beta1RuntimeClass[name]))}

function check_required(o::IoK8sApiNodeV1beta1RuntimeClass)
    o.handler === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiNodeV1beta1RuntimeClass }, name::Symbol, val)
end
