# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.rbac.v1.RoleBinding
RoleBinding references a role, but does not contain it.  It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.

    IoK8sApiRbacV1RoleBinding(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        roleRef=nothing,
        subjects=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - roleRef::IoK8sApiRbacV1RoleRef
    - subjects::Vector{IoK8sApiRbacV1Subject} : Subjects holds references to the objects the role applies to.
"""
Base.@kwdef mutable struct IoK8sApiRbacV1RoleBinding <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    roleRef = nothing # spec type: Union{ Nothing, IoK8sApiRbacV1RoleRef }
    subjects::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiRbacV1Subject} }

    function IoK8sApiRbacV1RoleBinding(apiVersion, kind, metadata, roleRef, subjects, )
        OpenAPI.validate_property(IoK8sApiRbacV1RoleBinding, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiRbacV1RoleBinding, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiRbacV1RoleBinding, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiRbacV1RoleBinding, Symbol("roleRef"), roleRef)
        OpenAPI.validate_property(IoK8sApiRbacV1RoleBinding, Symbol("subjects"), subjects)
        return new(apiVersion, kind, metadata, roleRef, subjects, )
    end
end # type IoK8sApiRbacV1RoleBinding

const _property_types_IoK8sApiRbacV1RoleBinding = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("roleRef")=>"IoK8sApiRbacV1RoleRef", Symbol("subjects")=>"Vector{IoK8sApiRbacV1Subject}", )
OpenAPI.property_type(::Type{ IoK8sApiRbacV1RoleBinding }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiRbacV1RoleBinding[name]))}

function check_required(o::IoK8sApiRbacV1RoleBinding)
    o.roleRef === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiRbacV1RoleBinding }, name::Symbol, val)
end
