# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.rbac.v1beta1.Role
Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding. Deprecated in v1.17 in favor of rbac.authorization.k8s.io/v1 Role, and will no longer be served in v1.20.

    IoK8sApiRbacV1beta1Role(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        rules=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - rules::Vector{IoK8sApiRbacV1beta1PolicyRule} : Rules holds all the PolicyRules for this Role
"""
Base.@kwdef mutable struct IoK8sApiRbacV1beta1Role <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    rules::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApiRbacV1beta1PolicyRule} }

    function IoK8sApiRbacV1beta1Role(apiVersion, kind, metadata, rules, )
        OpenAPI.validate_property(IoK8sApiRbacV1beta1Role, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiRbacV1beta1Role, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiRbacV1beta1Role, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiRbacV1beta1Role, Symbol("rules"), rules)
        return new(apiVersion, kind, metadata, rules, )
    end
end # type IoK8sApiRbacV1beta1Role

const _property_types_IoK8sApiRbacV1beta1Role = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("rules")=>"Vector{IoK8sApiRbacV1beta1PolicyRule}", )
OpenAPI.property_type(::Type{ IoK8sApiRbacV1beta1Role }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiRbacV1beta1Role[name]))}

function check_required(o::IoK8sApiRbacV1beta1Role)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiRbacV1beta1Role }, name::Symbol, val)
end
