# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.api.storage.v1.VolumeAttachment
VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.  VolumeAttachment objects are non-namespaced.

    IoK8sApiStorageV1VolumeAttachment(;
        apiVersion=nothing,
        kind=nothing,
        metadata=nothing,
        spec=nothing,
        status=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - spec::IoK8sApiStorageV1VolumeAttachmentSpec
    - status::IoK8sApiStorageV1VolumeAttachmentStatus
"""
Base.@kwdef mutable struct IoK8sApiStorageV1VolumeAttachment <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    metadata = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta }
    spec = nothing # spec type: Union{ Nothing, IoK8sApiStorageV1VolumeAttachmentSpec }
    status = nothing # spec type: Union{ Nothing, IoK8sApiStorageV1VolumeAttachmentStatus }

    function IoK8sApiStorageV1VolumeAttachment(apiVersion, kind, metadata, spec, status, )
        OpenAPI.validate_property(IoK8sApiStorageV1VolumeAttachment, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApiStorageV1VolumeAttachment, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApiStorageV1VolumeAttachment, Symbol("metadata"), metadata)
        OpenAPI.validate_property(IoK8sApiStorageV1VolumeAttachment, Symbol("spec"), spec)
        OpenAPI.validate_property(IoK8sApiStorageV1VolumeAttachment, Symbol("status"), status)
        return new(apiVersion, kind, metadata, spec, status, )
    end
end # type IoK8sApiStorageV1VolumeAttachment

const _property_types_IoK8sApiStorageV1VolumeAttachment = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("spec")=>"IoK8sApiStorageV1VolumeAttachmentSpec", Symbol("status")=>"IoK8sApiStorageV1VolumeAttachmentStatus", )
OpenAPI.property_type(::Type{ IoK8sApiStorageV1VolumeAttachment }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiStorageV1VolumeAttachment[name]))}

function check_required(o::IoK8sApiStorageV1VolumeAttachment)
    o.spec === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApiStorageV1VolumeAttachment }, name::Symbol, val)
end
