# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.apimachinery.pkg.apis.meta.v1.APIGroup
APIGroup contains the name, the supported versions, and the preferred version of a group.

    IoK8sApimachineryPkgApisMetaV1APIGroup(;
        apiVersion=nothing,
        kind=nothing,
        name=nothing,
        preferredVersion=nothing,
        serverAddressByClientCIDRs=nothing,
        versions=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - name::String : name is the name of the group.
    - preferredVersion::IoK8sApimachineryPkgApisMetaV1GroupVersionForDiscovery
    - serverAddressByClientCIDRs::Vector{IoK8sApimachineryPkgApisMetaV1ServerAddressByClientCIDR} : a map of client CIDR to server address that is serving this group. This is to help clients reach servers in the most network-efficient way possible. Clients can use the appropriate server address as per the CIDR that they match. In case of multiple matches, clients should use the longest matching CIDR. The server returns only those CIDRs that it thinks that the client can match. For example: the master will return an internal IP CIDR only, if the client reaches the server using an internal IP. Server looks at X-Forwarded-For header or X-Real-Ip header or request.RemoteAddr (in that order) to get the client IP.
    - versions::Vector{IoK8sApimachineryPkgApisMetaV1GroupVersionForDiscovery} : versions are the versions supported in this group.
"""
Base.@kwdef mutable struct IoK8sApimachineryPkgApisMetaV1APIGroup <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    preferredVersion = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1GroupVersionForDiscovery }
    serverAddressByClientCIDRs::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApimachineryPkgApisMetaV1ServerAddressByClientCIDR} }
    versions::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApimachineryPkgApisMetaV1GroupVersionForDiscovery} }

    function IoK8sApimachineryPkgApisMetaV1APIGroup(apiVersion, kind, name, preferredVersion, serverAddressByClientCIDRs, versions, )
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIGroup, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIGroup, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIGroup, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIGroup, Symbol("preferredVersion"), preferredVersion)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIGroup, Symbol("serverAddressByClientCIDRs"), serverAddressByClientCIDRs)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIGroup, Symbol("versions"), versions)
        return new(apiVersion, kind, name, preferredVersion, serverAddressByClientCIDRs, versions, )
    end
end # type IoK8sApimachineryPkgApisMetaV1APIGroup

const _property_types_IoK8sApimachineryPkgApisMetaV1APIGroup = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("kind")=>"String", Symbol("name")=>"String", Symbol("preferredVersion")=>"IoK8sApimachineryPkgApisMetaV1GroupVersionForDiscovery", Symbol("serverAddressByClientCIDRs")=>"Vector{IoK8sApimachineryPkgApisMetaV1ServerAddressByClientCIDR}", Symbol("versions")=>"Vector{IoK8sApimachineryPkgApisMetaV1GroupVersionForDiscovery}", )
OpenAPI.property_type(::Type{ IoK8sApimachineryPkgApisMetaV1APIGroup }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApimachineryPkgApisMetaV1APIGroup[name]))}

function check_required(o::IoK8sApimachineryPkgApisMetaV1APIGroup)
    o.name === nothing && (return false)
    o.versions === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApimachineryPkgApisMetaV1APIGroup }, name::Symbol, val)
end
