# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.apimachinery.pkg.apis.meta.v1.APIResource
APIResource specifies the name of a resource and whether it is namespaced.

    IoK8sApimachineryPkgApisMetaV1APIResource(;
        categories=nothing,
        group=nothing,
        kind=nothing,
        name=nothing,
        namespaced=nothing,
        shortNames=nothing,
        singularName=nothing,
        storageVersionHash=nothing,
        verbs=nothing,
        version=nothing,
    )

    - categories::Vector{String} : categories is a list of the grouped resources this resource belongs to (e.g. &#39;all&#39;)
    - group::String : group is the preferred group of the resource.  Empty implies the group of the containing resource list. For subresources, this may have a different value, for example: Scale\&quot;.
    - kind::String : kind is the kind for the resource (e.g. &#39;Foo&#39; is the kind for a resource &#39;foo&#39;)
    - name::String : name is the plural name of the resource.
    - namespaced::Bool : namespaced indicates if a resource is namespaced or not.
    - shortNames::Vector{String} : shortNames is a list of suggested short names of the resource.
    - singularName::String : singularName is the singular name of the resource.  This allows clients to handle plural and singular opaquely. The singularName is more correct for reporting status on a single item and both singular and plural are allowed from the kubectl CLI interface.
    - storageVersionHash::String : The hash value of the storage version, the version this resource is converted to when written to the data store. Value must be treated as opaque by clients. Only equality comparison on the value is valid. This is an alpha feature and may change or be removed in the future. The field is populated by the apiserver only if the StorageVersionHash feature gate is enabled. This field will remain optional even if it graduates.
    - verbs::Vector{String} : verbs is a list of supported kube verbs (this includes get, list, watch, create, update, patch, delete, deletecollection, and proxy)
    - version::String : version is the preferred version of the resource.  Empty implies the version of the containing resource list For subresources, this may have a different value, for example: v1 (while inside a v1beta1 version of the core resource&#39;s group)\&quot;.
"""
Base.@kwdef mutable struct IoK8sApimachineryPkgApisMetaV1APIResource <: OpenAPI.APIModel
    categories::Union{Nothing, Vector{String}} = nothing
    group::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    namespaced::Union{Nothing, Bool} = nothing
    shortNames::Union{Nothing, Vector{String}} = nothing
    singularName::Union{Nothing, String} = nothing
    storageVersionHash::Union{Nothing, String} = nothing
    verbs::Union{Nothing, Vector{String}} = nothing
    version::Union{Nothing, String} = nothing

    function IoK8sApimachineryPkgApisMetaV1APIResource(categories, group, kind, name, namespaced, shortNames, singularName, storageVersionHash, verbs, version, )
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("categories"), categories)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("group"), group)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("namespaced"), namespaced)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("shortNames"), shortNames)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("singularName"), singularName)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("storageVersionHash"), storageVersionHash)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("verbs"), verbs)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("version"), version)
        return new(categories, group, kind, name, namespaced, shortNames, singularName, storageVersionHash, verbs, version, )
    end
end # type IoK8sApimachineryPkgApisMetaV1APIResource

const _property_types_IoK8sApimachineryPkgApisMetaV1APIResource = Dict{Symbol,String}(Symbol("categories")=>"Vector{String}", Symbol("group")=>"String", Symbol("kind")=>"String", Symbol("name")=>"String", Symbol("namespaced")=>"Bool", Symbol("shortNames")=>"Vector{String}", Symbol("singularName")=>"String", Symbol("storageVersionHash")=>"String", Symbol("verbs")=>"Vector{String}", Symbol("version")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApimachineryPkgApisMetaV1APIResource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApimachineryPkgApisMetaV1APIResource[name]))}

function check_required(o::IoK8sApimachineryPkgApisMetaV1APIResource)
    o.kind === nothing && (return false)
    o.name === nothing && (return false)
    o.namespaced === nothing && (return false)
    o.singularName === nothing && (return false)
    o.verbs === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApimachineryPkgApisMetaV1APIResource }, name::Symbol, val)
end
