# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.apimachinery.pkg.apis.meta.v1.DeleteOptions_v2
DeleteOptions may be provided when deleting an API object.

    IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2(;
        apiVersion=nothing,
        dryRun=nothing,
        gracePeriodSeconds=nothing,
        kind=nothing,
        orphanDependents=nothing,
        preconditions=nothing,
        propagationPolicy=nothing,
    )

    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - dryRun::Vector{String} : When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    - gracePeriodSeconds::Int64 : The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - orphanDependents::Bool : Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \&quot;orphan\&quot; finalizer will be added to/removed from the object&#39;s finalizers list. Either this field or PropagationPolicy may be set, but not both.
    - preconditions::IoK8sApimachineryPkgApisMetaV1Preconditions
    - propagationPolicy::String : Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: &#39;Orphan&#39; - orphan the dependents; &#39;Background&#39; - allow the garbage collector to delete the dependents in the background; &#39;Foreground&#39; - a cascading policy that deletes all dependents in the foreground.
"""
Base.@kwdef mutable struct IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2 <: OpenAPI.APIModel
    apiVersion::Union{Nothing, String} = nothing
    dryRun::Union{Nothing, Vector{String}} = nothing
    gracePeriodSeconds::Union{Nothing, Int64} = nothing
    kind::Union{Nothing, String} = nothing
    orphanDependents::Union{Nothing, Bool} = nothing
    preconditions = nothing # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1Preconditions }
    propagationPolicy::Union{Nothing, String} = nothing

    function IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2(apiVersion, dryRun, gracePeriodSeconds, kind, orphanDependents, preconditions, propagationPolicy, )
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("apiVersion"), apiVersion)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("dryRun"), dryRun)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("gracePeriodSeconds"), gracePeriodSeconds)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("orphanDependents"), orphanDependents)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("preconditions"), preconditions)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2, Symbol("propagationPolicy"), propagationPolicy)
        return new(apiVersion, dryRun, gracePeriodSeconds, kind, orphanDependents, preconditions, propagationPolicy, )
    end
end # type IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2

const _property_types_IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2 = Dict{Symbol,String}(Symbol("apiVersion")=>"String", Symbol("dryRun")=>"Vector{String}", Symbol("gracePeriodSeconds")=>"Int64", Symbol("kind")=>"String", Symbol("orphanDependents")=>"Bool", Symbol("preconditions")=>"IoK8sApimachineryPkgApisMetaV1Preconditions", Symbol("propagationPolicy")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2 }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2[name]))}

function check_required(o::IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2 }, name::Symbol, val)
    if name === Symbol("gracePeriodSeconds")
        OpenAPI.validate_param(name, "IoK8sApimachineryPkgApisMetaV1DeleteOptionsV2", :format, val, "int64")
    end
end
