# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.apimachinery.pkg.apis.meta.v1.StatusDetails_v2
StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response. The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.

    IoK8sApimachineryPkgApisMetaV1StatusDetailsV2(;
        causes=nothing,
        group=nothing,
        kind=nothing,
        name=nothing,
        retryAfterSeconds=nothing,
        uid=nothing,
    )

    - causes::Vector{IoK8sApimachineryPkgApisMetaV1StatusCause} : The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.
    - group::String : The group attribute of the resource associated with the status StatusReason.
    - kind::String : The kind attribute of the resource associated with the status StatusReason. On some operations may differ from the requested resource Kind. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - name::String : The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).
    - retryAfterSeconds::Int64 : If specified, the time in seconds before the operation should be retried. Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.
    - uid::String : UID of the resource. (when there is a single resource which can be described). More info: http://kubernetes.io/docs/user-guide/identifiers#uids
"""
Base.@kwdef mutable struct IoK8sApimachineryPkgApisMetaV1StatusDetailsV2 <: OpenAPI.APIModel
    causes::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IoK8sApimachineryPkgApisMetaV1StatusCause} }
    group::Union{Nothing, String} = nothing
    kind::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    retryAfterSeconds::Union{Nothing, Int64} = nothing
    uid::Union{Nothing, String} = nothing

    function IoK8sApimachineryPkgApisMetaV1StatusDetailsV2(causes, group, kind, name, retryAfterSeconds, uid, )
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1StatusDetailsV2, Symbol("causes"), causes)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1StatusDetailsV2, Symbol("group"), group)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1StatusDetailsV2, Symbol("kind"), kind)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1StatusDetailsV2, Symbol("name"), name)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1StatusDetailsV2, Symbol("retryAfterSeconds"), retryAfterSeconds)
        OpenAPI.validate_property(IoK8sApimachineryPkgApisMetaV1StatusDetailsV2, Symbol("uid"), uid)
        return new(causes, group, kind, name, retryAfterSeconds, uid, )
    end
end # type IoK8sApimachineryPkgApisMetaV1StatusDetailsV2

const _property_types_IoK8sApimachineryPkgApisMetaV1StatusDetailsV2 = Dict{Symbol,String}(Symbol("causes")=>"Vector{IoK8sApimachineryPkgApisMetaV1StatusCause}", Symbol("group")=>"String", Symbol("kind")=>"String", Symbol("name")=>"String", Symbol("retryAfterSeconds")=>"Int64", Symbol("uid")=>"String", )
OpenAPI.property_type(::Type{ IoK8sApimachineryPkgApisMetaV1StatusDetailsV2 }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApimachineryPkgApisMetaV1StatusDetailsV2[name]))}

function check_required(o::IoK8sApimachineryPkgApisMetaV1StatusDetailsV2)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sApimachineryPkgApisMetaV1StatusDetailsV2 }, name::Symbol, val)
    if name === Symbol("retryAfterSeconds")
        OpenAPI.validate_param(name, "IoK8sApimachineryPkgApisMetaV1StatusDetailsV2", :format, val, "int32")
    end
end
