# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceSpec
APIServiceSpec contains information for locating and communicating with a server. Only https is supported, though you are able to disable certificate verification.

    IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec(;
        caBundle=nothing,
        group=nothing,
        groupPriorityMinimum=nothing,
        insecureSkipTLSVerify=nothing,
        service=nothing,
        version=nothing,
        versionPriority=nothing,
    )

    - caBundle::Vector{UInt8} : CABundle is a PEM encoded CA bundle which will be used to validate an API server&#39;s serving certificate. If unspecified, system trust roots on the apiserver are used.
    - group::String : Group is the API group name this server hosts
    - groupPriorityMinimum::Int64 : GroupPriorityMininum is the priority this group should have at least. Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We&#39;d recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s
    - insecureSkipTLSVerify::Bool : InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. This is strongly discouraged.  You should use the CABundle instead.
    - service::IoK8sKubeAggregatorPkgApisApiregistrationV1ServiceReference
    - version::String : Version is the API version this server hosts.  For example, \&quot;v1\&quot;
    - versionPriority::Int64 : VersionPriority controls the ordering of this API version inside of its group.  Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). Since it&#39;s inside of a group, the number can be small, probably in the 10s. In case of equal version priorities, the version string will be used to compute the order inside a group. If the version string is \&quot;kube-like\&quot;, it will sort above non \&quot;kube-like\&quot; version strings, which are ordered lexicographically. \&quot;Kube-like\&quot; versions start with a \&quot;v\&quot;, then are followed by a number (the major version), then optionally the string \&quot;alpha\&quot; or \&quot;beta\&quot; and another number (the minor version). These are sorted first by GA &gt; beta &gt; alpha (where GA is a version with no suffix such as beta or alpha), and then by comparing major version, then minor version. An example sorted list of versions: v10, v2, v1, v11beta2, v10beta3, v3beta1, v12alpha1, v11alpha2, foo1, foo10.
"""
Base.@kwdef mutable struct IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec <: OpenAPI.APIModel
    caBundle::Union{Nothing, Vector{UInt8}} = nothing
    group::Union{Nothing, String} = nothing
    groupPriorityMinimum::Union{Nothing, Int64} = nothing
    insecureSkipTLSVerify::Union{Nothing, Bool} = nothing
    service = nothing # spec type: Union{ Nothing, IoK8sKubeAggregatorPkgApisApiregistrationV1ServiceReference }
    version::Union{Nothing, String} = nothing
    versionPriority::Union{Nothing, Int64} = nothing

    function IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec(caBundle, group, groupPriorityMinimum, insecureSkipTLSVerify, service, version, versionPriority, )
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("caBundle"), caBundle)
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("group"), group)
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("groupPriorityMinimum"), groupPriorityMinimum)
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("insecureSkipTLSVerify"), insecureSkipTLSVerify)
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("service"), service)
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("version"), version)
        OpenAPI.validate_property(IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec, Symbol("versionPriority"), versionPriority)
        return new(caBundle, group, groupPriorityMinimum, insecureSkipTLSVerify, service, version, versionPriority, )
    end
end # type IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec

const _property_types_IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec = Dict{Symbol,String}(Symbol("caBundle")=>"Vector{UInt8}", Symbol("group")=>"String", Symbol("groupPriorityMinimum")=>"Int64", Symbol("insecureSkipTLSVerify")=>"Bool", Symbol("service")=>"IoK8sKubeAggregatorPkgApisApiregistrationV1ServiceReference", Symbol("version")=>"String", Symbol("versionPriority")=>"Int64", )
OpenAPI.property_type(::Type{ IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec[name]))}

function check_required(o::IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec)
    o.groupPriorityMinimum === nothing && (return false)
    o.service === nothing && (return false)
    o.versionPriority === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec }, name::Symbol, val)
    if name === Symbol("caBundle")
        OpenAPI.validate_param(name, "IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec", :format, val, "byte")
    end
    if name === Symbol("caBundle")
        OpenAPI.validate_param(name, "IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec", :pattern, val, r"^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$")
    end
    if name === Symbol("groupPriorityMinimum")
        OpenAPI.validate_param(name, "IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec", :format, val, "int32")
    end
    if name === Symbol("versionPriority")
        OpenAPI.validate_param(name, "IoK8sKubeAggregatorPkgApisApiregistrationV1APIServiceSpec", :format, val, "int32")
    end
end
